Create Procedure [prAddMailContent]
(
	@strUserId nvarchar(30),
	@strDomain varchar(255),
	@iMailboxIdx smallInt,
	@strSendIp char(15),
	@strReplyTo varchar(512),
	@iPriority tinyint,
	@strFrom nvarchar(512),
	@strTo ntext,
	@strCc ntext,
	@strSendDate DateTime,
	@strReceiveDate DateTime,
	@strSubject nvarchar(445),
	@strBodyHtmlCharset varchar(50),
	@strBodyHtml ntext,
	@strBodyTextCharset varchar(50),
	@strBodyText ntext,
	@iAttachCount int,
	@strMailfile nvarchar(255),
	@iSize int,
	@iMailboxNo smallint OUTPUT,
--2011.09.16 idx  ߰
	@iMailNo bigint OUTPUT
	
)
As
Begin
	Declare @iMax int,
		@iMailCount int,
		@iUserCount int,
		@iUserMod int,
		@iDomainNo int,
		@iTableNo int,
		@strDomainNo char(4),
		@strTableNo char(4),
		@strTableName char(30),
		@strIsView char(1),
		@iViewCount int,
		@strIsDefault char(1),
		@iSaveDay smallint,
		@iTotalSize bigint,
		@iMailboxSize bigint,
		@strMailboxName varchar(100),
		@varSql nvarchar(3000),
		@params nvarchar(2000)

	--  ϵǾ ִ   ȮѴ.
	Select @iDomainNo = NDL_IDX From NM_DOMAIN_LIST Where NDL_DOMAIN = @strDomain

	If @iDomainNo Is Null
		Return -1

	-- ڰ ϵǾ ִ ȮѴ.
	If Not Exists(Select User_No From Mail_User Where User_Id = @strUserId And User_Domain = @strDomain)
		Return -2

	--   Ǵ ̺ ȣ ´.
	Select @iMailboxSize = USER_MAILBOX_SIZE, @iTableNo = NM_TBL_NO From Mail_User Where User_Id = @strUserId And User_Domain = @strDomain

	-- ڰ ϰ ִ Ϲڽ  뷮 ´.
	Select @iTotalSize = Sum(M_Use_Size) From Nm_Mail_Box Where M_User_Id = @strUserId And M_User_Domain = @strDomain

	-- ڿ Ҵ 뷮
	Set @iMailboxSize = @iMailboxSize * 1048576
	-- ڰ ϰ ִ 뷮
	--Set @iTotalSize = @iTotalSize + @iSize

	-- 뷮 üũ
	-- Ҵ 뷮  ϰ ִ 뷮 ũ  ̻  ʴ´.
	If @iTotalSize > @iMailboxSize
		Return -3

	-- ̺ ȣ Null ̸ ̺ ȣ Ѵ.
	If @iTableNo Is Null
	Begin
		Select @iUserCount = Nm_Tbl_No From (Select Nm_Tbl_No, Count(User_No) As User_Count From Mail_User Where User_Domain = @strDomain Group By Nm_Tbl_No) As UC Where UC.User_Count < 20 Order By Nm_Tbl_No
		
		If @iUserCount Is Null
		Begin
			Select @iUserCount = Nm_Tbl_No From Mail_User Where User_Domain = @strDomain Group By Nm_Tbl_No Order By Nm_Tbl_No * -1
			Set @iUserCount = @iUserCount + 1
		End
		
		--   ̺ ȣ  ڶ ̺ ȣ Ʈ Ѵ.
		Update Mail_User Set NM_TBL_NO = @iUserCount Where User_Id = @strUserId And User_Domain = @strDomain

		Set @strTableNo = Cast(@iUserCount as varchar(4))
	End
	Else
		Set @strTableNo = Cast(@iTableNo as varchar(4))

	Set @strDomainNo = Cast(@iDomainNo as varchar(4))

	--   ̺ Ѵ.
	Set @strTableName = 'Nm_Mail_Content_' + RTrim(@strDomainNo) + '_' + RTrim(@strTableNo)

	If Not Exists(Select * From SysObjects Where Id = object_id(N'[' + @strTableName + ']') And OBJECTPROPERTY(id, N'IsUserTable') = 1)
	Begin
		Set @varSql = 'Create Table ' + @strTableName + ' ( '
		Set @varSql = @varSql + 'Mc_Idx bigint IDENTITY (1, 1) NOT NULL ,  '
		Set @varSql = @varSql + 'Mc_Mailbox_No smallint Not Null , '
		Set @varSql = @varSql + 'MC_User_Id nvarchar (30) Not Null , '
		Set @varSql = @varSql + 'MC_Domain varchar (255) Not Null , '
		Set @varSql = @varSql + 'MC_Mailbox_Idx smallInt Not Null, '
		Set @varSql = @varSql + 'MC_Send_Ip char (15) Null , '
		Set @varSql = @varSql + 'MC_Reply_To varchar (512) Null , '
		Set @varSql = @varSql + 'MC_Priority tinyint Null Default(2) , '
		Set @varSql = @varSql + 'MC_From nvarchar (512) Not Null , '
		Set @varSql = @varSql + 'MC_To ntext Not Null , '
		Set @varSql = @varSql + 'MC_Cc ntext Null , '
		Set @varSql = @varSql + 'MC_Send_Date datetime Not Null , '
		Set @varSql = @varSql + 'MC_Receive_Date datetime Not Null , '
		Set @varSql = @varSql + 'MC_Subject nvarchar (445) Not Null , '
		Set @varSql = @varSql + 'MC_Body_Html_Charset varchar (50) Null , '
		Set @varSql = @varSql + 'MC_Body_Html ntext Null , '
		Set @varSql = @varSql + 'MC_Body_Text_Charset varchar (50) Null , '
		Set @varSql = @varSql + 'MC_Body_Text ntext Null , '
		Set @varSql = @varSql + 'MC_Attach_Count smallint Not Null , '
		Set @varSql = @varSql + 'MC_Is_Read bit Not Null , '
		Set @varSql = @varSql + 'MC_Read_Date datetime Null , '
		Set @varSql = @varSql + 'MC_Is_Reply bit Not Null , '
		Set @varSql = @varSql + 'MC_Reply_Date datetime Null , '
		Set @varSql = @varSql + 'MC_Is_All_Reply bit Not Null , '
		Set @varSql = @varSql + 'MC_All_Reply_Date datetime Null , '
		Set @varSql = @varSql + 'MC_Is_Forward bit Not Null , '
		Set @varSql = @varSql + 'MC_Forward_Date datetime Null , '
		Set @varSql = @varSql + 'MC_Filename nvarchar (255) Not Null , '
		Set @varSql = @varSql + 'MC_Size int Not Null , '
		Set @varSql = @varSql + 'Constraint pk_' + RTrim(@strTableName) + '_idx Primary Key (MC_IDX), '
		Set @varSql = @varSql + 'Constraint chk_' + RTrim(@strTableName) + '_priority Check (MC_Priority = 3 or (Mc_Priority = 2 or Mc_Priority = 1)) '
		Set @varSql = @varSql + ')'
		
		exec sp_executeSql @varSql
		
		--  ε 
		Set @varSql = 'Create Index IX_' + RTrim(@strTableName) + '_Subject On ' + RTrim(@strTableName) + ' (Mc_Idx, Mc_Mailbox_Idx, Mc_Subject)'
		
		exec sp_executeSql @varSql
		
		--  ¥ ε 
		Set @varSql = 'Create Index IX_' + RTrim(@strTableName) + '_ReceiveDate On ' + RTrim(@strTableName) + ' (Mc_Idx, Mc_Mailbox_Idx, Mc_Receive_Date)'
		
		exec sp_executeSql @varSql
		
		-- ϸ ε 
		Set @varSql = 'Create Index IX_' + RTrim(@strTableName) + '_Filename On ' + RTrim(@strTableName) + ' (Mc_Idx, Mc_Mailbox_Idx, Mc_Filename)'
		
		exec sp_executeSql @varSql

		--  & Ϲڽ ε 
		Set @varSql = 'Create Index IX_' + RTrim(@strTableName) + '_User_Id On ' + RTrim(@strTableName) + ' (Mc_Idx, Mc_Mailbox_Idx, Mc_User_Id, Mc_Domain) '
		
		exec sp_executeSql @varSql
	End

	-- DB Ϸ ϴ  ϵǾ ִ ȮѴ.
	Set @varSql = 'Select @MailboxNo = Mc_Mailbox_No From ' + @strTableName + ' '
	Set @varSql = @varSql + 'Where Mc_Filename = @MailFile And Mc_User_Id = @UserId And Mc_Domain = @Domain '
	Set @params = '@MailFile varchar(255), @UserId varchar(30), @Domain varchar(255), @MailboxNo int OUTPUT'

	exec sp_executesql @varSql, @params, @MailFile = @strMailFile, @UserId = @strUserId, @Domain = @strDomain, @MailboxNo = @iMailboxNo OUTPUT

	If @iMailboxNo Is Not Null
		Return -4

	/*
	--  ̵  Ѵ.
	Set @varSql = 'Select @iMax = IsNull(Max(Mc_Idx), 0) + 1 From ' + @strTableName + ' '
	Set @params = '@iMax int OUTPUT'

	exec sp_executeSql @varSql, @params, @iMax = @iMax OUTPUT
	*/


	--  ڽ ȣ   ´.

	Set @varSql = 'Select Top 1 @mailCount = Mail_Count, @mailboxNo = Mc_Mailbox_No From '
	Set @varSql = @varSql + ' (Select Count(Mc_Idx) As Mail_Count, Mc_Mailbox_No From ' + @strTableName + ' '
	Set @varSql = @varSql + '    Where Mc_User_id = @userId And Mc_Domain = @domain Group By Mc_Mailbox_No) As Mail_Content '
	Set @varSql = @varSql + '    Order By Mc_Mailbox_No * -1, Mail_Count'
	Set @params = '@userId varchar(30), @domain varchar(255), @mailCount int OUTPUT, @mailboxNo int OUTPUT'

	exec sp_executeSql @varSql, @params, @userId = @strUserId, @domain = @strDomain, @mailCount = @iMailCount OUTPUT, @mailboxNo = @iMailboxNo OUTPUT

	-- Ϲڽ ȣ Null ϶ 1 ʱȭ

	If @iMailboxNo Is Null
	Begin
		Set @varSql = 'Select @mailboxNo = Max(Mc_Mailbox_No) From ' + @strTableName + ' Where Mc_User_Id = @userId And Mc_Domain = @domain'
		Set @params = '@userId varchar(30), @domain varchar(255), @mailboxNo int OUTPUT'
		
		exec sp_executeSql @varSql, @params, @userId = @strUserId, @domain = @strDomain, @mailboxNo = @iMailboxNo OUTPUT

		If @iMailboxNo Is Null
			Set @iMailboxNo = 1
		Else
			Set @iMailboxNo = @iMailboxNo + 1
	End

	--   Null ϶ 0 ʱȭ
	If @iMailCount Is Null
		Set @iMailCount = 1

	--   5000 ̻϶ Ϲڽ  1  Ų.
	If @iMailCount > 5000
		Set @iMailboxNo = @iMailboxNo + 1
	
	-- 2014.03.26 - ߿䵵  .
	-- X-Priority  1, 2, 3  ƴ 쿡 DB Է½ CHECK   ߻ؼ 0 Ǵ 4 ̻   쿡  ؼ ϰ Ѵ.
	-- 0~2  ߿䵵 , 3 , 4 ̻  
	-- ߿䵵  1 , 2 , 3 
	If @iPriority >= 0 And @iPriority <= 2
		Set @iPriority = 1
	Else
	Begin
		If @iPriority = 3
			Set @iPriority = 2
		Else
		Begin
			If @iPriority >= 4
				Set @iPriority = 3
		End
	End
	
	Set @varSql = 'Insert Into ' + @strTableName + ' ('
	Set @varSql = @varSql + 'MC_Mailbox_No,	Mc_User_Id,	Mc_Domain,	Mc_Mailbox_Idx,	MC_Send_Ip,	MC_Reply_To,	MC_Priority, '
	Set @varSql = @varSql + 'MC_From,	Mc_To,	Mc_Cc,		Mc_Send_Date,	Mc_Receive_Date,	Mc_Subject, '
	Set @varSql = @varSql + 'Mc_Body_Html_Charset,	Mc_Body_Html,	Mc_Body_Text_Charset,	Mc_Body_Text,	Mc_Attach_Count,		Mc_Is_Read, '
	Set @varSql = @varSql + 'Mc_Read_Date,		Mc_Is_Reply,	Mc_Reply_Date,	Mc_Is_All_Reply,	Mc_All_Reply_Date,		Mc_Is_Forward, '
	Set @varSql = @varSql + 'Mc_Forward_Date,	Mc_FIlename,	Mc_Size '
	Set @varSql = @varSql + ') Values ('
	Set @varSql = @varSql + '@iMailboxNo,	@strUserId,	@strDomain,	@iMailboxIdx,	@strSendIp,	@strReplyTo,	@iPriority, '
	Set @varSql = @varSql + '@strFrom,	@strTo,	@strCc,		@strSendDate,	@strReceiveDate,	@strSubject,	@strBodyHtmlCharset,	@strBodyHtml, '
	Set @varSql = @varSql + '@strBodyTextCharSet,	@strBodyText,	@iAttachCount,	0,	Null,	0,	Null,	0,	Null,	0,	Null, '
	Set @varSql = @varSql + '@strMailfile,	@iSize) '

	Set @params = '@iMailboxNo int, @strUserId varchar(30), @strDomain varchar(255), @iMailboxIdx smallInt, @strSendIp char(15), @strReplyTo varchar(512), '
	Set @params = @params + '@iPriority tinyint, @strFrom nvarchar(512), @strTo ntext, @strCc ntext, @strSendDate DateTime, @strReceiveDate DateTime, @strSubject nvarchar(445), '
	Set @params = @params + '@strBodyHtmlCharset varchar(50), @strBodyHtml ntext, @strBodyTextCharset varchar(50), @strBodyText ntext, @iAttachCount int, '
	Set @params = @params + '@strMailfile varchar(255), @iSize int '

	exec sp_executeSql @varSql, @params, @iMailboxNo = @iMailboxNo, @strUserId = @strUserId, @strDomain = @strDomain, @iMailboxIdx = @iMailboxIdx, @strSendIp = @strSendIp,
			@strReplyTo = @strReplyTo, @iPriority = @iPriority, @strFrom = @strFrom, @strTo = @strTo, @strCc = @strCc, @strSendDate = @strSendDate, @strReceiveDate = @strReceiveDate,
			@strSubject = @strSubject, @strBodyHtmlCharSet = @strBodyHtmlCharSet, @strBodyHtml = @strBodyHtml, @strBodyTextCharSet = @strBodyTextCharSet, @strBodyText = @strBodyText,
			@iAttachCount = @iAttachCount, @strMailfile = @strMailfile, @iSize = @iSize

	Update Mail_User Set
		Current_Size = IsNull(Current_Size, 0) + @iSize
	Where
		User_Id = @strUserId And User_Domain = @strDomain

	If Not Exists(Select Mailbox_No From Nm_Mail_Box Where M_Idx = @iMailboxIdx And M_User_Id = @strUserId And M_User_Domain = @strDomain)
	Begin
		If @iMailboxIdx = 1
		Begin
			Set @strMailboxName = ''
			Set @strIsView = 'Y'
			Set @iViewCount = 5
			Set @strIsDefault = 'Y'
			Set @iSaveDay = 0
		End
		Else
		Begin
			If @iMailboxIdx = 401
			Begin
				Set @strMailboxName = ''
				Set @strIsView = 'N'
				Set @iViewCount = 0
				Set @strIsDefault = 'Y'
				Set @iSaveDay = 60
			End
			Else
			Begin
				If @iMailboxIdx = 101
				Begin
					Set @strMailboxName = ''
					Set @strIsView = 'N'
					Set @iViewCount = 0
					Set @strIsDefault = 'Y'
					Set @iSaveDay = 0
				End
				Else
				Begin
					Select @strMailboxName = IsNull(M_Mailbox_Name, '') From Nm_Mail_box Where M_Idx = @iMailboxIdx And M_User_Id = @strUserId And M_User_Domain = @strDomain
					Set @strIsView = 'N'
					Set @iViewCount = 0
					Set @strIsDefault = 'N'
					Set @iSaveDay = 0
				End
			End
		End

		Select @iMax = IsNull(Max(Mailbox_No), 0) + 1 From Nm_Mail_Box
		
		Insert Into Nm_Mail_Box 
			(Mailbox_No, M_User_Id, M_User_Domain, M_Idx, M_Depth, M_Mailbox_Ref, M_Mailbox_Name, M_Mail_Count, M_Use_Size, M_IS_DEFAULT, M_Save_Day, M_Is_Main_View, M_Main_View_Count, M_NO_READ_COUNT) 
		Values
			(@iMax, @strUserId, @strDomain, @iMailboxIdx, 0, @iMailboxIdx, @strMailboxName, 1, @iSize, @strIsDefault, @iSaveDay, @strIsView, @iViewCount, 1)
	End
	Else
	Begin
		Update Nm_Mail_Box Set
			M_Mail_Count = M_Mail_Count + 1, M_Use_Size = M_Use_Size + @iSize,
			M_No_Read_Count = M_No_Read_Count + 1
		Where
			M_Idx = @iMailboxIdx And M_User_Id = @strUserId And M_User_Domain = @strDomain
	End


	--2011.09.16 idx  ߰
	Set @varSql = 'Select @iMailNo = Mc_Idx From ' + @strTableName + ' Where Mc_User_Id = @userId And Mc_Domain = @domain And Mc_FIlename = @strMailfile'
	Set @params = '@userId varchar(30), @domain varchar(255), @strMailfile nvarchar(255), @iMailNo int OUTPUT'

	exec sp_executeSql @varSql, @params, @userId = @strUserId, @domain = @strDomain, @strMailfile =@strMailfile,  @iMailNo = @iMailNo OUTPUT

	If @@ERROR <> 0
		Return @@ERROR

	Return 0
End
GO

Create Procedure [prWeekSchedule]
	(
		@varUserId varchar(30),
		@varDomain varchar(255),
		@chrFirstWeekDay char(10),
		@chrLastWeekDay char(10),
		@varType char(1)
	)

As
Begin
	--2012.01.17  ζ SCH_PUBLIC = @varType ߰.
	Select
		Str(SCH_NO) As SCH_NO, SOL_YEAR, SOL_MONTH, SOL_DAY, SCH_ST_HOUR, SCH_ST_MINUTE, SCH_ED_HOUR, SCH_ED_MINUTE, SCH_TITLE, SCH_PUBLIC
	From
		SCHEDULE
	Where
		(--  
			@varType = 'N' And
			(SOL_YEAR + '-' + SOL_MONTH + '-' + SOL_DAY >= @chrFirstWeekDay And SOL_YEAR + '-' + SOL_MONTH + '-' + SOL_DAY <= @chrLastWeekDay) And
			USER_ID = @varUserId And USER_DOMAIN = @varDomain And SCH_PUBLIC = @varType
		) Or
		(--  
			@varType = 'Y' And 
			(SOL_YEAR + '-' + SOL_MONTH + '-' + SOL_DAY >= @chrFirstWeekDay And SOL_YEAR + '-' + SOL_MONTH + '-' + SOL_DAY <= @chrLastWeekDay) And
			USER_DOMAIN = @varDomain And SCH_PUBLIC = @varType
		)

	If @@ERROR <> 0
		return @@ERROR

	Return 0
End
GO

CREATE Procedure [prInsertDocInfo]
	(
		@iBrdNo int,
		@varDomain varchar(255),
		@varWriterId nvarchar(255),
		@varSubject nvarchar(255),
		@txtContent text,
		@varRemoteIp char(15),
		@varAttachFile varchar(255),
		@iAttachSize numeric(10, 0)
	)
As
Begin
	Declare @iMaxDocNo int
	Declare @iMaxDocViewNo int

	Select @iMaxDocNo = ISNULL(Max(DOC_NO), 0) + 1 From DOC_INFO
	Select @iMaxDocViewNo = IsNull(Max(DOC_VIEW_NO), 0) + 1 From DOC_INFO Where BRD_NO = @iBrdNo And DOC_DOMAIN = @varDomain

	Insert Into DOC_INFO (DOC_NO, BRD_NO, DOC_DOMAIN, DOC_WRITER_ID, DOC_WRITE_TYPE, DOC_SUBJECT, DOC_CONTENT,
				DOC_WRITE_DATE, DOC_READ_CNT, DOC_RECOM_CNT, DOC_REMOTE_IP,
				DOC_VIEW_NO, DOC_REF_NO, DOC_STEP, DOC_SORT, DOC_ATTACH_FILE, DOC_ATTACH_SIZE)
	Values
		(@iMaxDocNo, @iBrdNo, @varDomain, @varWriterId, 'HTML', @varSubject, @txtContent, GetDate(), 0, 0, @varRemoteIp,
		@iMaxDocViewNo, @iMaxDocNo, 0, 0, @varAttachFile, @iAttachSize)

	If @@ERROR <> 0
		Return @@ERROR

	Return 0
End
GO

CREATE Procedure [prModifyDoc]
	(
		@iBrdNo int,
		@iDocNo int,
		@varDomain varchar(255),
		@varSubject nvarchar(255),
		@txtContent text,
		@varAttachFile varchar(255),
		@iAttachSize numeric(10, 0),
		@varRtnVal varchar(100) OUTPUT
	)
As
Begin
	If Not Exists(Select DOC_NO From DOC_INFO Where DOC_NO = @iDocNo And BRD_NO = @iBrdNo And DOC_DOMAIN = @varDomain)
	Begin
		Set @varRtnVal = 'Ϸ Խù  ʽϴ.' +char(13)+char(10)+ 'Խù ȣ: ' +Str(@iDocNo)
		Return -1
	End

	Update DOC_INFO Set
		DOC_SUBJECT = @varSubject,
		DOC_CONTENT = @txtContent,
		DOC_ATTACH_FILE = @varAttachFile,
		DOC_ATTACH_SIZE = @iAttachSize
	Where
		DOC_NO = @iDocNo And
		BRD_NO = @iBrdNo And
		DOC_DOMAIN = @varDomain

	If @@ERROR <> 0
		Return @@ERROR
End
GO

CREATE Procedure [prReplyDoc]
	(
		@iBrdNo int,
		@iDocNo int,
		@varDomain varchar(255),
		@varWriterId nvarchar(255),
		@varSubject nvarchar(255),
		@txtContent text,
		@varRemoteIp char(15),
		@varAttachFile varchar(255),
		@iAttachSize numeric(10, 0),
		@varRtnVal varchar(255) OUTPUT
	)
As
Begin
	Declare @iMaxDocNo int
	Declare @iRefNo int
	Declare @iStep int
	Declare @iSort int
	Declare @iMaxDocSort int

	If Not Exists(Select DOC_NO From DOC_INFO Where DOC_NO = @iDocNo And BRD_NO = @iBrdNo And DOC_DOMAIN = @varDomain)
	Begin
		Set @varRtnVal = '亯 ޷  Խù  ϴ.' +char(13)+char(10)+ 'Խù ȣ: ' + Str(@iDocNo)
		Return - 1
	End

	Select 
		@iRefNo = IsNull(DOC_REF_NO, 0), @iStep = IsNull(DOC_STEP, 0), @iSort = IsNull(DOC_SORT, 0) 
	From 
		DOC_INFO 
	Where
		DOC_NO = @iDocNo And BRD_NO = @iBrdNo And DOC_DOMAIN = @varDomain

	If @iStep = 0
	Begin
		Select @iSort = IsNull(Max(DOC_SORT), 0) + 1 From DOC_INFO where DOC_REF_NO = @iRefNo And BRD_no = @iBrdNo And DOC_DOMAIN = @varDomain
		Set @iStep = @iStep + 1
	End
	Else
	Begin
		Select @iMaxDocSort = IsNull(Max(DOC_SORT), 0) From DOC_INFO Where DOC_STEP > @iStep And DOC_SORT > @iSort And DOC_REF_NO = @iRefNo And BRD_no = @iBrdNo And DOC_DOMAIN = @varDomain
		If @iMaxDocSort <> 0
			Set @iSort = @iMaxDocSort

		Update DOC_INFO Set DOC_SORT = DOC_SORT + 1 Where DOC_SORT > @iSort And DOC_REF_NO = @iRefNo And BRD_no = @iBrdNo And DOC_DOMAIN = @varDomain

		Set @iStep = @iStep + 1
		Set @iSort = @iSort + 1
	End

	Select @iMaxDocNo = IsNull(Max(DOC_NO), 0) + 1 From DOC_INFO

	Insert Into DOC_INFO 
	(DOC_NO, BRD_NO, DOC_DOMAIN, DOC_WRITER_ID, DOC_WRITE_TYPE, DOC_SUBJECT, DOC_CONTENT, DOC_WRITE_DATE, 
	DOC_READ_CNT, DOC_RECOM_CNT, DOC_REMOTE_IP, DOC_VIEW_NO, DOC_REF_NO, DOC_STEP, DOC_SORT,
	DOC_ATTACH_FILE, DOC_ATTACH_SIZE) Values
	(@iMaxDocNo, @iBrdNo, @varDomain, @varWriterId,  'HTML', @varSubject, @txtContent, getDate(), 0, 0, @varRemoteIp,
	0, @iRefNo, @iStep, @iSort, @varAttachFile, @iAttachSize)

	If @@ERROR <> 0
		Return @@ERROR
End
GO

CREATE Procedure webversionupdate
As
Begin
	Declare @strtemp varchar(255)
	
	Set @strtemp = ''
	
	If Not Exists (select NEC_FIELD_NAME from NM_ENGINE_CONFIG where NEC_FIELD_NAME = 'WELCOMEMSG')
	Begin
		SELECT @strtemp = ISNULL(NEC_FIELD_VALUE, '') FROM NM_ENGINE_CONFIG WHERE NEC_FIELD_NAME = 'ROOT_DOMAIN'
		
		INSERT INTO NM_ENGINE_CONFIG([NEC_FIELD_TYPE],[NEC_FIELD_NAME] ,[NEC_FIELD_VALUE]) VALUES('SMTPCONFIG','WELCOMEMSG' , @strtemp + ' Web version 4.5.5')
	END
	ELSE
	Begin
		 UPDATE NM_ENGINE_CONFIG SET NEC_FIELD_VALUE = ISNULL((SELECT NEC_FIELD_VALUE FROM NM_ENGINE_CONFIG WHERE NEC_FIELD_NAME = 'ROOT_DOMAIN'), '') + ' Web version 4.5.5' WHERE NEC_FIELD_NAME = 'WELCOMEMSG' 
	END
End
GO
