﻿using System;
using System.Collections;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

/// <summary>
/// Domain의 요약 설명입니다.
/// </summary>
public class Domain
{
    private string _Domain = "";
    private int iAllocateSize = 0;
    private int iUseSize = 0;
    private int iUserCount = 0;
    private int iJoinUserCount = 0;
    private string strJoinType = "";
    private int iDefaultSize = 0;
    private string strPop3Allow = "";
    private bool bUseGroup = false;
    private string strCopyright = "";
    private string strErrMsg = "";
    //2010.12.27 추가
    private string strImap4 = "";

    //2011.8.25 추가
    private string strWebname = "";
    private string strCompany = "";
    private string strTel = "";
    private string strEmail = "";
    private string strJoin = "";
    private string strSsl = "";

    private OleDbConnection Con;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter Param = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataTable dt = new DataTable();
    private DataSet ds = new DataSet();

    public Domain()
	{
		//
		// TODO: 생성자 논리를 여기에 추가합니다.
		//
	}

    public void LoadDomain(string strCon)
    {
        if (strCon.Trim() == "")
            throw new Exception("DB 연결 문자열이 입력되지 않았습니다.");

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception e)
        {
            throw new Exception(e.Message);
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prLoadDomain";

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, _Domain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strReturnValue", OleDbType.VarChar, 600);
            Param.Direction = ParameterDirection.Output;

            Cmd.Parameters["@strDomain"].Value = _Domain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "NM_DOMAIN_LIST");
            dt = ds.Tables["NM_DOMAIN_LIST"];

            if (dt != null)
            {
                if (dt.Rows.Count > 0)
                {
                    DataRow dr = dt.Rows[0];

                    iAllocateSize = int.Parse(dr["NDL_ALLOW_SIZE"].ToString());
                    iUseSize = int.Parse(dr["NDL_USE_SIZE"].ToString());
                    iUserCount = int.Parse(dr["NDL_USER_COUNT"].ToString());
                    iJoinUserCount = int.Parse(dr["USER_COUNT"].ToString());

                    //2010.02.10 무조건 대문자로 입력되게 수정함.
                    strJoinType = dr["NDL_SMTP_ALLOW"].ToString().ToUpper();
                    
                    iDefaultSize = int.Parse(dr["NDL_DEFAULT_SIZE"].ToString());
                    
                    //2010.02.10 무조건 대문자로 입력되게 수정함.
                    strPop3Allow = dr["NDL_POP3_ALLOW"].ToString().ToUpper();
                    
                    strCopyright = dr["NDL_COPYRIGHT"].ToString();

                    if (dr["Ndl_Use_Group"].ToString() == "Y")
                        bUseGroup = true;

                    //2010.12.27 impa4 추가
                    strImap4 = dr["NDL_IMAP4_ALLOW"].ToString().ToUpper();


                    //2011.08.25 추가
                    strWebname = dr["NDL_WEBNAME"].ToString();
                    strCompany = dr["NDL_COMPANY"].ToString();
                    strTel = dr["NDL_TEL"].ToString();
                    strEmail = dr["NDL_EMAIL"].ToString();
                    strJoin = dr["NDL_JOIN"].ToString();
                    strSsl = dr["NDL_SSL"].ToString();
                }
            }
        }
        catch (Exception e)
        {
            throw new Exception(e.Message);
        }
        finally
        {
            Con.Close();
        }
    }

    
    public static string chkSsl(string strDomain, string strCon)
    {
        OleDbConnection Con;
        string ssl = "";

        if (strCon.Trim() == "")
            throw new Exception("DB 연결 문자열이 입력되지 않았습니다.");

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception e)
        {
            throw new Exception(e.Message);
        }
        try
        {
            string strsql = "SELECT NDL_SSL FROM NM_DOMAIN_LIST where NDL_DOMAIN = '" + strDomain + "'";

            OleDbDataAdapter Adap = new OleDbDataAdapter(strsql, strCon);
            DataTable dt = new DataTable();
            DataSet ds = new DataSet();

            Adap.Fill(ds, "NM_DOMAIN_LIST");
            // 데이터 셋에 있는 데이터를 테이블만 데이터 테이블 객체로 옮긴다.
            dt = ds.Tables["NM_DOMAIN_LIST"];

            // 데이터가 있으면 해당 데이터를 각 필드에 넣는다.
            if (dt.Rows.Count > 0)
            {
                DataRow dr = dt.Rows[0];
                ssl = dr["NDL_SSL"].ToString();
            }
        }
        catch (Exception e)
        {
            throw new Exception(e.Message);
        }
        finally
        {
            Con.Close();
        }
        return ssl;
    }

    public static string[] GetAliasDomain(string strDomain, string strCon)
    {
        OleDbConnection Con;
        OleDbDataAdapter Adap;
        OleDbCommand Cmd = new OleDbCommand();
        DataTable dt = new DataTable();

        string strSql = "";
        string[] aliasDomain = null;

        if (strCon.Trim() == "")
            throw new Exception("DB 연결 문자열이 입력되지 않았습니다.");

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception e)
        {
            throw new Exception(e.Message);
        }

        try
        {
            strSql = "SELECT NDA_ALIAS_DOMAIN FROM NM_DOMAIN_ALIAS WHERE NDA_DOMAIN = ?";

            Cmd.Connection = Con;

            Cmd.CommandText = strSql;
            Cmd.CommandType = CommandType.Text;

            Cmd.Parameters.Clear();

            Cmd.Parameters.Add("@varDomain", OleDbType.VarChar).Value = strDomain;

            Adap = new OleDbDataAdapter(Cmd);

            Adap.Fill(dt);

            if (dt.Rows.Count > 0)
            {
                aliasDomain = new string[dt.Rows.Count];

                for (int i = 0; i < dt.Rows.Count; i++)
                    aliasDomain[i] = dt.Rows[i][0].ToString();
            }

        }
        catch (Exception e)
        {
            throw new Exception(e.Message);
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }

        return aliasDomain;
    }

    public string GetDomain(string domain)
    {
        ArrayList DomainList = Passkorea.Configuration.DomainList();
        string strDomain = domain;

        if (DomainList != null)
        {
            bool bDomain = false;
            int iCnt = domain.Split('.').Length;

            // 도메인이 아이피인지 확인한다.
            
            if (iCnt == 4)
            {
                if (DomainCheckIp(strDomain))
                    strDomain = Passkorea.Configuration.DomainList()[0].ToString();
            }
            
            for (int i = 0; i < iCnt; i++)
            {
                for (int iDomainCount = 0; iDomainCount < DomainList.Count; iDomainCount++)
                {
                    strErrMsg += DomainList[iDomainCount].ToString() + "<br>";
                    if (DomainList[iDomainCount].ToString() == strDomain)
                    {
                        strDomain = DomainList[iDomainCount].ToString();
                        bDomain = true;
                        break;
                    }
                }

                if (bDomain)
                    break;

                int iPos = strDomain.IndexOf(".");

                if (iPos > -1)
                    strDomain = strDomain.Substring(iPos + 1);
            }

            if (!bDomain)
            {
                strErrMsg = "입력된 도메인은 메일서버에 등록되지 않은 도메인 입니다.\r\n접속 하는 도메인을 확인해주시거나 서버 관리자에게 문의하세요.\r\n" +
                    "접속도메인: " + domain;
                return "";
            }
        }
        else
        {
            strErrMsg = "메일서버에 도메인이 등록되어 있지 않습니다.\r\n서버 관리자에게 문의하세요.\r\n" + Passkorea.Configuration.GetErrorMessage;
            strDomain = "";
        }

        return strDomain;
    }

    private bool DomainCheckIp(string strValue)
    {
        bool bIp = false;
        if (strValue.Trim() == "")
        {
            return false;
        }

        string[] strIp = strValue.Split('.');

        for (int i = 0; i < strIp.Length; i++)
        {
            try
            {
                int iIp = int.Parse(strIp[i]);
            }
            catch
            {
                bIp = false;
                break;
            }

            bIp = true;
        }

        return bIp;
    }

    public string DomainName
    {
        set { _Domain = value; }
    }

    public int AllocateSize
    {
        get { return iAllocateSize; }
    }

    public int UseSize
    {
        get { return iUseSize; }
    }

    public int UserCount
    {
        get { return iUserCount; }
    }

    public int JoinUserCount
    {
        get { return iJoinUserCount; }
    }

    public string JoinType
    {
        get { return strJoinType; }
    }

    public int DefaultSize
    {
        get { return iDefaultSize; }
    }

    public string Pop3Allow
    {
        get { return strPop3Allow; }
    }

    public bool UseGroup
    {
        get { return bUseGroup; }
    }

    public string Copyright
    {
        get { return strCopyright; }
    }

    public string ErrorMessage
    {
        get { return strErrMsg; }
    }

    public string Imap4
    {
        get { return strImap4; }
    }

    //2011.08.25추가
    public string Webname
    {
        get { return strWebname; }
    }
    public string Company
    {
        get { return strCompany; }
    }
    public string Tel
    {
        get { return strTel; }
    }
    public string Email
    {
        get { return strEmail; }
    }
    public string Ssl
    {
        get { return strSsl; }
    }
    public string Join
    {
        get { return strJoin; }
    }

}