﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

/// <summary>
/// UserInfo의 요약 설명입니다.
/// </summary>
public class UserInfo
{
    private string strSql = "";
	private string tblMailUser = "";
	private string fldUserNo = "";
	private string fldUserId = "";
	private string fldUserPwd = "";
	private string fldUserName = "";
	private string fldUserPath = "";
	private string fldUserDomain = "";
	private string fldUserMaxSize = "";
	private string fldUserAuthority = "";
	private string fldUserMailing = "";
	private string strErrMsg = "";

	private string sUserId = "";
	private string sDomain = "";
	private string sCon = "";

	private int mUserNo = 0;
	private int mUserMaxSize = 0;
	private string mUserPwd = "";
	private string mUserName = "";
	private string mUserPath = "";
	private string mUserPermit = "";
	private string mUserAuthority = "";
    private string mPop3Allow = "";
    private long mWebhardAllocateSize = 0;
    private string mWebhardPermission = "";
    private string mWebhardPath = "";
    private bool mWebhardAllow = false;
	private string mUserMailing = "N";
	private string mLoginDate = "";
    // 발신자 메일주소 변경
    private bool bUseSenderEmail = false;
    private string mSenderEmail = "";   
    private int iDefaultWebhardSize = int.Parse(ConfigurationSettings.AppSettings["UserDefaultSize"].ToString());
    private string strDefaultWebhardPath = ConfigurationSettings.AppSettings["WebhardPath"].ToString();

    //2009.07.27 대용량 메일발송
    private long mBigFileSize = 0;
    private string mBigFilePath = "";
    private int iDefaultmBigFileSize = int.Parse(ConfigurationSettings.AppSettings["BigFileDefaultSize"].ToString());
    private string strDefaultBigFilePath = ConfigurationSettings.AppSettings["BigFilePath"].ToString();
    private long mBigFileTotSize = 0;

    private long __lUseSize = 0;
    private string __strPath = "";

    //2012.01.18 업로드 타입(엑티브 엑스or텍스트 모드)와 수신확인 남김여부 추가.
    private string strFile_Up_Type="";
    private string strMail_Confirm_Allow="";


	public UserInfo()
	{
		//
		// TODO: 여기에 생성자 논리를 추가합니다.
		//01.20.08
        tblMailUser = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "mailuser");
        fldUserNo = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "id");
        fldUserId = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "users");
        fldUserPwd = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "pw");
        fldUserName = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "name");
        fldUserPath = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "path");
        fldUserDomain = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "domain");
        fldUserMaxSize = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "maxsize");
        fldUserAuthority = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "use_allow");
        fldUserMailing = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "mailinglist");

		tblMailUser = this.CheckIsNull(tblMailUser, "MAIL_USER");
		fldUserNo = this.CheckIsNull(fldUserNo, "USER_NO");
		fldUserId = this.CheckIsNull(fldUserId, "USER_ID");
		fldUserPwd = this.CheckIsNull(fldUserPwd, "USER_PWD");
		fldUserName = this.CheckIsNull(fldUserName, "USER_NAME");
		fldUserPath = this.CheckIsNull(fldUserPath, "USER_MAILBOX_PATH");
		fldUserDomain = this.CheckIsNull(fldUserDomain, "USER_DOMAIN");
		fldUserMaxSize = this.CheckIsNull(fldUserMaxSize, "USER_MAILBOX_SIZE");
		fldUserAuthority = this.CheckIsNull(fldUserAuthority, "USER_AUTHORITY");
		fldUserMailing = this.CheckIsNull(fldUserMailing, "IS_MAILING");
	}

	#region 사용자 정보 셋팅
	/// <summary>
	/// 사용자 정보를 셋팅한다.
	/// </summary>
	/// <param name="strUserId"></param>
	/// <param name="strDomain"></param>
	/// <param name="strCon"></param>
	public UserInfo(string strUserId, string strDomain, string strCon)
	{
        tblMailUser = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "mailuser");
        fldUserNo = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "id");
        fldUserId = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "users");
        fldUserPwd = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "pw");
        fldUserName = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "name");
        fldUserPath = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "path");
        fldUserDomain = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "domain");
        fldUserMaxSize = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "maxsize");
        fldUserAuthority = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "use_allow");
        fldUserMailing = "";// Passkorea.Configuration.GetConfigField("fieldinfo", "mailinglist");

		tblMailUser = this.CheckIsNull(tblMailUser, "MAIL_USER");
		fldUserNo = this.CheckIsNull(fldUserNo, "USER_NO");
		fldUserId = this.CheckIsNull(fldUserId, "USER_ID");
		fldUserPwd = this.CheckIsNull(fldUserPwd, "USER_PWD");
		fldUserName = this.CheckIsNull(fldUserName, "USER_NAME");
		fldUserPath = this.CheckIsNull(fldUserPath, "USER_MAILBOX_PATH");
		fldUserDomain = this.CheckIsNull(fldUserDomain, "USER_DOMAIN");
		fldUserMaxSize = this.CheckIsNull(fldUserMaxSize, "USER_MAILBOX_SIZE");
		fldUserAuthority = this.CheckIsNull(fldUserAuthority, "USER_AUTHORITY");
		fldUserMailing = this.CheckIsNull(fldUserMailing, "IS_MAILING");

		if (strUserId == "") return;
			
		if (strDomain == "") return;
			
		if (strCon == "") return;

		sUserId = strUserId;
		sDomain = strDomain;
		sCon = strCon;

		GetUserInfo(sUserId, sDomain, sCon);
	}
	#endregion

	#region 메일 엔진 사용자 정보
	/// <summary>
	/// 메일엔진에서 사용되는 사용자 정보를 가져온다.
	/// </summary>
	/// <param name="strUserId"></param>
	/// <param name="strDomain"></param>
	/// <param name="strCon"></param>
	private void GetUserInfo(string strUserId, string strDomain, string strCon)
	{
        string strTmp = "";
		// 커넥션 생성
        OleDbConnection Con = new OleDbConnection(strCon);

        //2012.01.18일 FILE_UP_TYPE,MAIL_CONFIRM_ALLOW 추가
		// 쿼리문
		strSql = "SELECT " + fldUserNo + ", " + fldUserPwd + ", " + fldUserName + ", " + fldUserPath +
			", " + fldUserAuthority + ", " + fldUserMailing + ", " + fldUserMaxSize +  ", " +
            "POP3_ALLOW, WEBHARD_ALLOW, WEBHARD_ALLOCATE_SIZE, WEBHARD_PERMISSION, WEBHARD_PATH, USER_PERMIT, " +
            "BIGFILE_PATH, BIGFILE_SIZE, BIGFILE_TOT_SIZE,FILE_UP_TYPE,MAIL_CONFIRM_ALLOW," + //bigfile 경로와 용량 부분 추가됨
            "USE_SENDER_EMAIL, SENDER_EMAIL_ADDR, " +
			"(SELECT TOP 1 CONN_DATE FROM LOGIN_INFO WHERE LOGIN_ID = '" + strUserId + "' AND USER_DOMAIN = '" + strDomain + "' ORDER BY CONN_DATE DESC) AS LOGIN_DATE " +
			" FROM " + tblMailUser + " AS MU LEFT JOIN USER_INFO AS UI ON " +
			"MU." + fldUserId + " = UI.USER_ID AND MU." + fldUserDomain + " = UI.USER_DOMAIN " +
			"WHERE MU." + fldUserId + " = '" + strUserId + "' AND MU." +
			fldUserDomain + " = '" + strDomain + "'";

        OleDbDataAdapter Adapter = new OleDbDataAdapter(strSql, Con);
		
        DataSet ds = new DataSet();
		DataTable dt = new DataTable();

        try
        {
            // 데이터 어댑터를 사용해서 데이터 셋에 데이터를 채운다.
            Adapter.Fill(ds, tblMailUser);
            // 데이터 셋에 있는 데이터를 테이블만 데이터 테이블 객체로 옮긴다.
            dt = ds.Tables[tblMailUser];

            // 데이터가 있으면 해당 데이터를 각 필드에 넣는다.
            if (dt.Rows.Count > 0)
            {
                DataRow dr = dt.Rows[0];

                mUserNo = int.Parse(dr[fldUserNo].ToString());
                mUserPwd = dr[fldUserPwd].ToString();
                mUserName = dr[fldUserName].ToString();
                mUserPath = dr[fldUserPath].ToString();
                mUserPermit = dr["USER_PERMIT"].ToString().Trim();
                mUserAuthority = dr[fldUserAuthority].ToString();
                mUserMaxSize = int.Parse(dr[fldUserMaxSize].ToString());
                mUserMailing = dr[fldUserMailing].ToString();
                mPop3Allow = dr["POP3_ALLOW"].ToString();
                mLoginDate = dr["LOGIN_DATE"].ToString();

                // 웹하드 사용여부
                strTmp = dr["WEBHARD_ALLOW"].ToString();

                if (strTmp == null)
                    mWebhardAllow = true;
                else if (strTmp == "" || strTmp.ToUpper() == "Y")
                    mWebhardAllow = true;
                else
                    mWebhardAllow = false;

                // 웹하드 설정 용량
                strTmp = dr["WEBHARD_ALLOCATE_SIZE"].ToString();

                if (strTmp == null)
                    mWebhardAllocateSize = iDefaultWebhardSize;
                else if (strTmp == "")
                    mWebhardAllocateSize = iDefaultWebhardSize;
                else
                    mWebhardAllocateSize = long.Parse(strTmp);

                // 웹하드 권한 설정
                strTmp = dr["WEBHARD_PERMISSION"].ToString();

                if (strTmp == null)
                    mWebhardPermission = "M1";
                else
                    mWebhardPermission = strTmp;

                // 웹하드 경로
                strTmp = dr["WEBHARD_PATH"].ToString();

                if (strTmp == null)
                    mWebhardPath = strDefaultWebhardPath + "\\" + strDomain + "\\User_Data\\" + strUserId;
                else if (strTmp == "")
                    mWebhardPath = strDefaultWebhardPath + "\\" + strDomain + "\\User_Data\\" + strUserId;
                else
                    mWebhardPath = strTmp;

                //2009.07.27 대용량 메일 파일 추가부분
                //대용량메일 파일 경로
                strTmp = dr["BIGFILE_PATH"].ToString();

                if (strTmp == null)
                    mBigFilePath = strDefaultBigFilePath + "\\" + strDomain + "\\Big_File_Data\\" + strUserId + "\\";
                else if (strTmp == "")
                    mBigFilePath = strDefaultBigFilePath + "\\" + strDomain + "\\Big_File_Data\\" + strUserId + "\\";
                else
                    mBigFilePath = strTmp + "\\";

                //대용량메일 파일 용량
                strTmp = dr["BIGFILE_SIZE"].ToString();
                if (strTmp == null)
                    mBigFileSize = iDefaultmBigFileSize;
                else if (strTmp == "")
                    mBigFileSize = iDefaultmBigFileSize;
                else
                    mBigFileSize = long.Parse(strTmp);
                
                //대용량메일 토탈 용량
                strTmp = dr["BIGFILE_TOT_SIZE"].ToString();
                if (strTmp == null)
                    mBigFileTotSize = 0;
                else if (strTmp == "")
                    mBigFileTotSize = 0;
                else
                    mBigFileTotSize = long.Parse(strTmp);

                //2012.01.18 첨부파일 타입, 메일수신 확인
                strFile_Up_Type = CheckIsNull(dr["FILE_UP_TYPE"].ToString(),"T");
                strMail_Confirm_Allow = CheckIsNull(dr["MAIL_CONFIRM_ALLOW"].ToString(), "Y");

                // 2014.04.15 - 발송자 메일주소 변경 사용 여부값 추가.
                mSenderEmail = dr["SENDER_EMAIL_ADDR"].ToString();

                if (dr["USE_SENDER_EMAIL"].ToString().ToUpper() == "Y")
                    bUseSenderEmail = true;
            }
            else
            {
                ErrMsg = strUserId + " 사용자가 등록되지 않았습니다.";
            }
        }
        catch (Exception err)
        {
            throw new Exception("사용자 정보를 가져오는 도중 오류가 발생했습니다.\r\n" +
                    "오류내용: " + err.Message + "\r\n" +
                    "사용 쿼리: " + strSql);

        }
        finally
        {
            Con.Close();
        }
	}
	#endregion

    #region 웹하드 사용량
    /// <summary>
    /// 웹하드 사용량
    /// </summary>
    /// <returns></returns>
    public long WebhardUseSize()
    {
        // 사용자 사용 용량을 초기화 한다.
        __lUseSize = 0;

        try
        {
            if (__strPath.Trim() == "")
            {
                // 사용자 경로값이 없을때 사용자 정보를 로드한다.
                GetUserInfo(sUserId, sDomain, sCon);

                __strPath = mWebhardPath;
            }

            Webhard_Passkorea wp = new Webhard_Passkorea();

            if (Directory.Exists(__strPath))
                __lUseSize = wp.CalcFullDirectorySize(__strPath);
            else
                wp.CreateDirectory(__strPath);
        }
        catch (UnauthorizedAccessException uae)
        {
            strErrMsg = uae.Message;
            __lUseSize = -1;
        }
        catch (AccessViolationException ave)
        {
            strErrMsg = ave.Message;
            __lUseSize = -1;
        }
        catch (Exception e)
        {
            strErrMsg = e.Message;
            __lUseSize = -1;
        }

        return __lUseSize;
    }
    #endregion

    #region 메일 전체 사용용량
    /// <summary>
    /// 메일 전체 사용용량
    /// </summary>
    /// <returns></returns>
    public long GetUseMailSize()
    {
        long useSize = 0;

        try
        {
            if (sUserId != "" && sDomain != "")
            {

                //2012.01.18 SetupModify 에서 검색 하도록 수정함.
                strSql = "Select Sum(M_Use_Size) As Mail_Size From Nm_Mail_Box Where M_User_Id = '" + sUserId + "' And M_User_Domain = '" + sDomain + "'";

                string strvalue = SetupModify.select(strSql);

                if (strvalue.IndexOf("오류가") == 0)
                    useSize = 0;
                else
                    useSize = long.Parse(strvalue);
            }
        }
        catch
        {
            useSize = 0;
        }

        return useSize;
    }
    #endregion

    #region 전체 사용자 수
    /// <summary>
	/// 전체 사용자 수
	/// </summary>
	/// <param name="strDomain"></param>
	/// <returns></returns>
	public int TotalUserCount(string strDomain)
	{
		int iUserCnt = 0;
		try
		{
			if (strDomain != "")
			{
                OleDbConnection Con = new OleDbConnection(sCon);
                OleDbCommand Cmd = new OleDbCommand();

				strSql = "SELECT COUNT(" + fldUserNo + ") AS USER_CNT FROM " +
                    tblMailUser + " WHERE USER_AUTHORITY='Y' And " + fldUserDomain + " = '" + strDomain + "'";

				Con.Open();
				Cmd.Connection = Con;
				Cmd.CommandType = CommandType.Text;
				Cmd.CommandText = strSql;
			
				iUserCnt = (int)Cmd.ExecuteScalar();

				Con.Close();
			} 
			else
				iUserCnt = 0;
		} 
		catch
		{
			iUserCnt = 0;
		}

		return iUserCnt;
	}
	#endregion

	#region 사용자 아이디
	/// <summary>
	/// 사용자 아이디 프로퍼티
	/// </summary>
	public int UserId
	{
		get { return mUserNo; }
	}
	#endregion

	#region 사용자 비밀번호
	/// <summary>
	/// 사용자 비밀번호 프로퍼티
	/// </summary>
	public string UserPwd
	{
		get { return mUserPwd; }
	}
	#endregion

	#region 사용자 이름
	/// <summary>
	/// 사용자 이름 프로퍼티
	/// </summary>
	public string UserName
	{
		get { return mUserName; }
	}
	#endregion

	#region 사용자 메일박스 경로
	/// <summary>
	/// 사용자 메일박스 경로 프로퍼티
	/// </summary>
	public string UserPath
	{
		get { return mUserPath; }
	}
	#endregion

	#region 사용자 메일 사용여부
	/// <summary>
	/// 사용자 메일 사용여부 프로퍼티
	/// </summary>
	public string UserPermit
	{
		get { return mUserPermit; }
	}
	#endregion

	#region 관리자 여부
	/// <summary>
	/// 관리자 여부 프로퍼티
	/// </summary>
	public string UserAuthority
	{
		get { return mUserAuthority; }
	}
	#endregion

	#region 사용자 메일박스 용량
	/// <summary>
	/// 사용자 메일박스 용량 프로퍼티
	/// </summary>
	public int UserMailBoxSize
	{
		get { return mUserMaxSize; }
	}
	#endregion

	#region 메일링 리스트 사용자 여부
	/// <summary>
	/// 메일링 리스트 사용자 여부 프로퍼티
	/// </summary>
	public string UserMailing
	{
		get { return mUserMailing; }
	}
	#endregion

    #region POP3 사용여부
    /// <summary>
    /// POP3 사용여부
    /// </summary>
    public string Pop3Allow
    {
        get { return mPop3Allow; }
    }
    #endregion

    #region 최종 로그인 시간
    // 최종 로그인 시간
	public string LoginDate
	{
		get { return mLoginDate; }
	}
	#endregion
    
    #region 웹하드 사용여부
    // 웹하드 사용여부
    public bool WebhardAllow
    {
        get { return mWebhardAllow; }
    }
    #endregion

    #region 웹하드 용량
    // 웹하드 용량
    public long WebhardAllocateSize
    {
        get { return mWebhardAllocateSize; }
    }
    #endregion

    #region 웹하드 권한
    // 웹하드 권한
    public string WebhardPermission
    {
        get { return mWebhardPermission; }
    }
    #endregion

    #region 웹하드 경로
    // 웹하드 경로
    public string WebhardPath
    {
        get { return mWebhardPath; }
    }
    #endregion

    //2009.07.27 대용량 메일추가에 대한 추가

    #region 대용량파일 경로
    // 대용량파일 경로
    public string BigFilePath
    {
        get { return mBigFilePath; }
    }
    #endregion

    #region 대용량파일 최대사이즈
    
    // 대용량파일 최대사이즈
    public long BigFileSize
    {
        get { return mBigFileSize; }
    }
    #endregion

    #region 업로드 타입
    public string File_Up_Type
    {
        get { return strFile_Up_Type; }
    }
    #endregion

    #region 수신확인
    public string Mail_Confirm_Allow
    {
        get { return strMail_Confirm_Allow; }
    }
    #endregion

    #region 현재사용중인 대용량 총사이즈
    // 현재 사용중인 대용량 파일 총사이즈
    public long BigFileTotSize
    {
        get { return mBigFileTotSize; }
    }
    #endregion

    #region 에러 메세지
    /// <summary>
	/// 에러 메세지 프로퍼티
	/// </summary>
	public string ErrMsg
	{
		get { return strErrMsg; }
		set { strErrMsg = value; }
	}
	#endregion

	#region 해당 문자가 공백 또는 null값이면 지정한 값으로 셋팅
	/// <summary>
	/// 해당 문자가 공백 또는 null값이면 지정한 값으로 셋팅
	/// </summary>
	/// <param name="strValue"></param>
	/// <param name="strRtnVal"></param>
	/// <returns></returns>
	private string CheckIsNull(string strValue, string strRtnVal)
	{
		if (strValue == "" || strValue == null)
			return strRtnVal;

		return strValue;
	}
	#endregion

    #region 발송자 메일주소 번호
    public string SenderEmailAddr
    {
        get { return mSenderEmail; }
    }
    #endregion

    #region 발송자 메일주소 변경 사용여부
    public bool UseSenderEmail
    {
        get { return bUseSenderEmail; }
    }
    #endregion
}
