﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Security.Cryptography;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.WebSource;

public partial class Log_Login : System.Web.UI.Page
{
    private System.Web.HttpCookie cookie;
    private OleDbConnection Con = null;
    private OleDbTransaction Trans = null;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter Param = new OleDbParameter();
    private string strCon = System.Configuration.ConfigurationSettings.AppSettings["strConnection"];
    //private string strDomain = ConfigurationSettings.AppSettings["strDomain"];

    private string strErrMsg;
    private UserInfo UI;
    private JavaScript JS;

    //2009.07.23 Root 경로 가져 넣는 변수 추가
    private string TempUrlRoot = "";

    //2009.10.08 web.config 에 설정되어 있는 대용량첨부 정보를 가져오는 부분.
    private int iDefaultmBigFileSize = int.Parse(ConfigurationSettings.AppSettings["BigFileDefaultSize"].ToString());
    private string strDefaultBigFilePath = ConfigurationSettings.AppSettings["BigFilePath"].ToString();

    //2011.08.25 private로 선언함.
    private Domain domain = new Domain();

    protected void Page_Load(object sender, EventArgs e)
    {
        
        string strScript = "";
        string strUserId = "";
        string strUserPwd = "";
        string strReturnUrl = "";
        
        JS = new JavaScript(this.Page);

        //2011.08.25 회원가입 버튼 채크 루틴 추가
        JoinCheck();

        if (!Page.IsPostBack)
        {
            //2011.12.01 userid로 해놓으면 쿠키값중 userid를 읽어와서 오류가 발생 그래서 userid가 아닌 다른걸로 수정함.
            strUserId = Request.Params["ssoiduser"];
            strUserPwd = Request.Params["ssouserpwd"];
            strReturnUrl = Request.Params["ssoreturnUrl"];

            if (strReturnUrl == null)
            {
                if (Request.Cookies["NMAIL_INFO"] != null)
                {
                    // 정상 패키지 로그인 셋팅
                    if (Server.HtmlEncode(Request.Cookies["NMAIL_INFO"]["IdSave"]) == "Yes")
                    {
                        chkUserIdSave.Checked = true;
                        tbUserId.Text = Server.HtmlEncode(Request.Cookies["NMAIL_INFO"]["USER_ID"]);
                    }
                    else
                    {
                        chkUserIdSave.Checked = false;
                        tbUserId.Text = "";
                    }
                }
            }
            else
            {
                if (!strReturnUrl.ToLower().StartsWith("http://"))
                    strReturnUrl = "http://" + strReturnUrl;

                
                this.UserLogin(strUserId, strUserPwd, strReturnUrl, false);
            }
        }

        strScript = "if (UserLogin()) return true; else return false;";
        ibUserLogin.Attributes.Add("onclick", strScript);
    }

    //2011.08.25 회원가입 버튼 채크 루틴 추가
    public void JoinCheck()
    {
        //2013.08.13 url에서 도메인을 가져 와야 하는데 가공없이 가져 오는거라서 잘못 나와서 수정함.
        domain.DomainName = domain.GetDomain(Request.Url.Host);
        domain.LoadDomain(strCon);

        if (domain.Join == "N")
            this.spjoin.Visible = false;
    }

    #region 쿠키값을 설정한다.
    /// <summary>
    /// 쿠키값을 설정한다.
    /// </summary>
    private void SetCookie()
    {
        string strUserId = tbUserId.Text;
        bool bUserIdSave = chkUserIdSave.Checked;
        string flag = "";

        if (strUserId != "")
        {
            if (bUserIdSave)
                flag = "Yes";
            else
                flag = "No";

            cookie = new HttpCookie("NMAIL_INFO");
            cookie["USER_ID"] = strUserId;
            cookie["DOMAIN"] = Session["MAIL_DOMAIN"].ToString();
            cookie["IDSAVE"] = flag;
            cookie.Expires = DateTime.Now.AddDays(365);
            cookie.Path = "/";
            
            Response.Cookies.Add(cookie);
        }
    }
     #endregion

    public void UserJoin(object sender, System.EventArgs e)
    {
        Response.Redirect("../User/UserJoin.aspx");
    }

    protected void ibUserLogin_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        //2011.08.25 로그인 페이지가 ssl일 경우 https로 되어 있어서 http로 들어가도록 하는 루틴 추가.
        if (domain.Ssl == "Y")
        {
            string strMoveUrl = "http://" + Request.Url.Host.ToString();
            string strAppPath = Request.ApplicationPath;

            if (!strMoveUrl.EndsWith("/")) strMoveUrl += "/";

            if (strAppPath.StartsWith("/") && strAppPath.Length > 1)
                strMoveUrl = strMoveUrl + strAppPath.Substring(1);

            if (!strMoveUrl.EndsWith("/")) strMoveUrl += "/";

            strMoveUrl += "Mail/Main.aspx";

            this.UserLogin(tbUserId.Text, tbUserPwd.Value, strMoveUrl, true);
        }
        else
            this.UserLogin(tbUserId.Text, tbUserPwd.Value, "../Mail/Main.aspx", true);
    }

    private void UserLogin(string userId, string userPwd, string strReturnUrl, bool bLocalLogin)
    {
        string strUserId = "";
        string strUserPwd = "";
        string strSessionID = Session.SessionID;
        string strRemoteIP = Request.UserHostAddress;
        string strDomain = Request.Url.Host;
        string strOrgUserPwd = "";
        int iValue = 0;

        //2009.07.20 웹메일 루트를 찾는다.
        //root 경로를 찾는다. strUrlRoot에 넣는다
        string strUrlRoot = Request.ApplicationPath;

        //그후 세선에 넣음
        if(strUrlRoot !="")
            Session["URL_ROOT"] = strUrlRoot;

        strUserId = userId.Trim();
        strUserPwd = userPwd.Trim();
        
        DataSet ds = new DataSet();
        DataTable dt = new DataTable();

        if (strUserId.Trim() == "")
        {
            JS.MessageBox("아이디를 입력해 주세요.");
            JS.HistoryBack();
            return;
        }
        else if (strUserPwd.Trim() == "")
        {
            JS.MessageBox("비밀번호를 입력해 주세요.");
            JS.HistoryBack();
            return;
        }

        // 도메인이 등록된 도메인인지 확인하고 등록되지 않은 도메인이면
        // 기본도메인으로 설정한다.
        strDomain = domain.GetDomain(strDomain);

        if (strDomain.Trim() == "")
        {
            JS.MessageBox(domain.ErrorMessage);
            JS.HistoryBack();
            return;
        }
        else
            Session["MAIL_DOMAIN"] = strDomain;

        if (strCon != "" && strCon != null)
        {
            try
            {
                if (Con == null)
                    Con = new OleDbConnection(strCon);

                Con.Open();
            }
            catch (Exception err)
            {
                JS.MessageBox("DB Connection Fail!!!\r\n" +
                    err.Message);
                JS.HistoryBack();
                return;
            }

            try
            {
                Cmd.Connection = Con;
                Cmd.CommandType = CommandType.StoredProcedure;
                Cmd.CommandText = "prLoadUserPwd";

                Cmd.Parameters.Clear();
                     

                // Command Parameter (Execute Return Value)
                Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
                Param.Direction = ParameterDirection.ReturnValue;

                Cmd.Parameters.Add("@varUserId", OleDbType.VarWChar).Value = strUserId;
                Cmd.Parameters.Add("@varDomain", OleDbType.VarWChar).Value = Session["MAIL_DOMAIN"].ToString();
                
                // Command Parameter (User Password)
                Param = Cmd.Parameters.Add("@varUserPwd", OleDbType.VarChar, 32);
                Param.Direction = ParameterDirection.Output;

                Cmd.ExecuteNonQuery();

                iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue != 0)
                {
                    if (iValue == -1)
                    {
                        JS.MessageBox("등록되지 않은 사용자 입니다. (" + strUserId + ")");
                        //JS.EndLodingPage();
                        JS.HistoryBack();
                        return;
                    }
                    else
                    {
                        JS.MessageBox("로그인하는 도중 오류 발생 SQL Error no: " + iValue.ToString());
                        //JS.EndLodingPage();
                        JS.HistoryBack();
                        return;
                    }
                }

                strOrgUserPwd = Cmd.Parameters["@varUserPwd"].Value.ToString();

                //2012.01.18 공통 모듈 common 에서 처리 하도록 수정함.
                //2010.04.12 md5 작업.
                //md5형식으로 변환한다.
                // 2009년 03월 23일
                // 비밀번호 확인 루틴 (MD5 암호화 루틴 추가)
                //if (strUserPwdType.ToUpper() == "MD5")
                strUserPwd = Common.EncodingMD5(strUserPwd);
                
                if (strUserPwd != strOrgUserPwd)
                {
                    JS.MessageBox("비밀번호가 틀렸습니다.");
                    //JS.EndLodingPage();
                    JS.HistoryBack();
                    return;
                }
                Cmd.CommandText = "prLoginUser";

                Cmd.Parameters.Clear();
                
                Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
                Param.Direction = ParameterDirection.ReturnValue;
                
                Cmd.Parameters.Add("@varUserId", OleDbType.VarWChar).Value = strUserId;
                Cmd.Parameters.Add("@varDomain", OleDbType.VarWChar).Value = Session["MAIL_DOMAIN"].ToString();
                Cmd.Parameters.Add("@varUserPwd", OleDbType.VarWChar).Value = strUserPwd;
                Cmd.Parameters.Add("@varSessionID", OleDbType.VarWChar).Value = strSessionID;
                Cmd.Parameters.Add("@varRemoteIP", OleDbType.VarWChar).Value = Request.UserHostAddress;
                
                Param = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 200);
                Param.Direction = ParameterDirection.Output;

                OleDbDataAdapter Adap = new OleDbDataAdapter(Cmd);
                Adap.Fill(ds, "MAIL_USER");
                dt = ds.Tables["MAIL_USER"];

                iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                if (iValue < 0)
                {
                    JS.MessageBox("로그인 하는 도중 오류가 발생했습니다.\r\n" +
                        "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString());
                    //JS.EndLodingPage();
                    JS.HistoryBack();
                    return;
                }
                else if (iValue != 0)
                {
                    JS.MessageBox("로그인 하는 도중 오류가 발생했습니다.\r\n" +
                        "SQL Error Number: " + iValue.ToString());
                    //JS.EndLodingPage();
                    JS.HistoryBack();
                    return;
                }
                
                Con.Close();

                //2009.10.08 로그인시 대용량첨부 경로,크기,pop3 제외 지정 부분을 가져와서 null 일때 값을 채워 준다.
                BigPath(strUserId, strDomain, strCon);

                //2011.05.18 기간이 지난 대용량 첨부 파일 삭제 한다.
                BigFileDelete(strUserId, strDomain, strCon);

                UI = new UserInfo(strUserId, strDomain, strCon);

                if (UI.ErrMsg != "")
                {
                    JS.MessageBox(UI.ErrMsg);
                    //JS.EndLodingPage();
                    return;
                }

                if (!Directory.Exists(UI.UserPath + "\\temp"))
                    Directory.CreateDirectory(UI.UserPath + "\\temp");

                Session["USER_ID"] = strUserId;
                
                // 쿠키 설정
                this.SetCookie();
            }
            catch (Exception err)
            {
                JS.MessageBox("로그인 하는 도중 오류가 발생했습니다.\r\n" +
                    "오류 내용: " + err.Message + "\r\n" +
                    "오류 발생 객체: " + err.Source);
                //JS.EndLodingPage();
                return;
            }
            
            AuthKey ak = new AuthKey();
            string strMsg = ak.CheckUserCount(UI.TotalUserCount(strDomain));

            if (strMsg != "")
                JS.MessageBox(strMsg);

            // 세션 허용시간 설정
            Session.Timeout = 60;

            JS.LodingPage("로그인 중입니다.");
            
            // 에러난 메일 처리
            JS.ChangeLodingPageMessage("DB 입력 오류 발생한 메일을 처리하고 있습니다.");
            ProcErrorMail(strUserId, strDomain);
            
            // 보관기간 지난 메일 삭제
            JS.ChangeLodingPageMessage("보관기간 지난 메일을 확인하고 있습니다.");
            ProcAutoDeleteMail(strUserId, strDomain);
            JS.EndLodingPage();

            //2009.07.20 로그인시 attach_temp 폴더,cid_temp 폴더 삭제
            try
            {
                DeleteTempDirectory();
            }
            catch (Exception exx)
            {
                JS.MessageBox(exx.Message +  "삭제에 실패 했습니다");
            }

            //2012.01.10 비밀번호 강화 모드
            string strNdlPwd = SetupModify.select("SELECT NDL_PWD FROM NM_DOMAIN_LIST WHERE NDL_DOMAIN = '" + strDomain + "'");

            if (strNdlPwd.IndexOf("오류가") == 0)
                JS.MessageBox(strNdlPwd);
            else if (strNdlPwd != "Y")
                JS.MovePage(strReturnUrl);
            else
            {
                string strPwdLog = SetupModify.select("SELECT PWD_LOG FROM MAIL_USER WHERE USER_ID = '" + strUserId + "' AND USER_DOMAIN = '" + strDomain + "'");

                if (strPwdLog.IndexOf("오류가") == 0)
                    JS.MessageBox(strPwdLog);
                else if (strPwdLog == "")
                {
                    string strValue = SetupModify.Modify("UPDATE MAIL_USER SET PWD_LOG = GETDATE() WHERE USER_ID = '" + strUserId + "' AND USER_DOMAIN = '" + strDomain + "'");

                    if (strValue.IndexOf("오류가") == 0)
                        JS.MessageBox(strValue);
                    else
                        JS.MovePage(strReturnUrl);
                }
                else
                {
                    //90일 이상이면 비밀번호 변경 페이지로 이동함.
                    if (DateTime.Parse(strPwdLog).AddDays(90) < DateTime.Today)
                        JS.MovePage("../User/UserPwd.aspx");
                    else
                        JS.MovePage(strReturnUrl);
                }
            }
        }
    }

    //2009.10.08 로그인시 대용량첨부 경로,크기,pop3 제외 지정 부분을 가져와서 null 일때 값을 채워 준다.
    #region 대용량첨부파일 경로
    private void BigPath(string id, string domain, string strcon)
    {
        string strbigfile_path = "";
        string strbigfile_size = "";
        string struser_pop3 = "";
        string strSql = "";
        //10.01.21 업로드 타입
        string strfile_up_type = "";

        OleDbConnection Conn = new OleDbConnection(strCon);

        // 쿼리문 대용량첨부 경로,크기,pop3 제외 지정 부분을 가져온다
        // 10.01.21 MAIL_USER 테이블에 FILE_UP_TYPE가 추가 되어 없을경우 강제로 값을 넣는거 추가함.
        strSql = "SELECT BIGFILE_PATH, BIGFILE_SIZE, USER_POP3EXCEPT_DIR FROM MAIL_USER WHERE USER_ID = '" + id + "' AND USER_DOMAIN = '" + domain + "'";

        OleDbDataAdapter Adapter = new OleDbDataAdapter(strSql, Conn);

        DataSet ds = new DataSet();
        DataTable dt = new DataTable();

        try
        {
            // 데이터 어댑터를 사용해서 데이터 셋에 데이터를 채운다.
            Adapter.Fill(ds, "MAIL_USER");
            // 데이터 셋에 있는 데이터를 테이블만 데이터 테이블 객체로 옮긴다.
            dt = ds.Tables["MAIL_USER"];

            // 데이터가 있으면 해당 데이터를 각 필드에 넣는다.
            if (dt.Rows.Count > 0)
            {
                DataRow dr = dt.Rows[0];

                strbigfile_path = dr["BIGFILE_PATH"].ToString();
                strbigfile_size = dr["BIGFILE_SIZE"].ToString();
                struser_pop3 = dr["USER_POP3EXCEPT_DIR"].ToString();

                Conn.Close();

                //2011.11.14 업데이트를 SetupModify 에서 변경하도록 수정합.
                if (strbigfile_path == null || strbigfile_path == "")
                {
                    string strdata = "UPDATE MAIL_USER SET BIGFILE_PATH = '" + strDefaultBigFilePath + "\\" + domain + "\\Big_File_Data\\" + id + "' WHERE USER_ID = '" + id + "' AND USER_DOMAIN = '" + domain + "'";
                    string strValue = SetupModify.Modify(strdata);
                    if (strValue.IndexOf("오류가") == 0)
                        throw new Exception(strValue);
                }

                if (strbigfile_size == null || strbigfile_size == "")
                {
                    string strdata = "UPDATE MAIL_USER SET BIGFILE_SIZE = " + iDefaultmBigFileSize + " WHERE USER_ID = '" + id + "' AND USER_DOMAIN = '" + domain + "'";
                    string strValue = SetupModify.Modify(strdata);
                    if (strValue.IndexOf("오류가") == 0)
                        throw new Exception(strValue);
                }

                if (struser_pop3 == null || struser_pop3 == "")
                {
                    string strdata = "UPDATE MAIL_USER SET USER_POP3EXCEPT_DIR = '101,201,301' WHERE USER_ID = '" + id + "' AND USER_DOMAIN = '" + domain + "'";
                    string strValue = SetupModify.Modify(strdata);
                    if (strValue.IndexOf("오류가") == 0)
                        throw new Exception(strValue);
                }
            }
            else
            {
                ErrMsg = id + " 사용자가 등록되지 않았습니다.";
            }
        }
        catch (Exception err)
        {
            throw new Exception("사용자 정보를 가져오는 도중 오류가 발생했습니다.\r\n" +
                    "오류내용: " + err.Message);
        }

        //2010년 10월 29일 메일박스테이블에 pop3 가져오기 부분 보강함.
        strSql = "SELECT M_IDX,M_POP3 FROM nm_mail_box WHERE M_USER_ID='" + id + "' AND M_USER_DOMAIN='" + domain + "' AND (M_IDX='101'OR M_IDX='201'OR M_IDX='301')";
        Adapter = new OleDbDataAdapter(strSql, Conn);

        ds = new DataSet();
        dt = new DataTable();

        try
        {
            
            string strtemp = "";
            string[] strtemp2 = null;
            string[] strtemp3 = null;

            // 데이터 어댑터를 사용해서 데이터 셋에 데이터를 채운다.
            Adapter.Fill(ds, "nm_mail_box");
            // 데이터 셋에 있는 데이터를 테이블만 데이터 테이블 객체로 옮긴다.
            dt = ds.Tables["nm_mail_box"];

            // 데이터가 있으면 해당 데이터를 각 필드에 넣는다.
            if (dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    strtemp +=dr["M_IDX"].ToString()+":"+dr["M_POP3"].ToString()+",";
                }
                
                Conn.Close();

                strtemp = strtemp.Substring(0, strtemp.Length-1);
                strtemp2 = strtemp.Split(',');

                for (int i = 0; i < strtemp2.Length; i++)
                {
                    strtemp3 = strtemp2[i].Split(':');

                    if (strtemp3[1] == null || strtemp3[1] == "")
                    {

                        //2011.11.14 업데이트를 SetupModify 에서 변경하도록 수정합.
                        string strdata = "UPDATE NM_MAIL_BOX SET M_POP3 = 'N' WHERE M_USER_ID = '" + id + "' AND M_USER_DOMAIN = '" + domain + "' AND M_IDX=" + strtemp3[0];
                        string strValue = SetupModify.Modify(strdata);
                        if (strValue.IndexOf("오류가") == 0)
                            throw new Exception(strValue);
                    }
                }
            }
            else
            {
                ErrMsg = id + " NM_MAIL_BOX테이블에 정보를 가져 오지 못했습니다..";
            }
        }
        catch (Exception err)
        {
            throw new Exception("사용자 정보를 가져오는 도중 오류가 발생했습니다.\r\n" +
                    "오류내용: " + err.Message);
        }
        finally
        {
            Conn.Close();
        }
    }
    #endregion 

    //2009.07.20 로그인시 임시폴더 삭제
    #region Temp 폴더 삭제
    private void DeleteTempDirectory()
    {
        DirectoryInfo di = new DirectoryInfo(UI.UserPath + "\\temp");

        if (di.Exists)
        {
            di.Delete(true);
            di.Create();
        }
        di = new DirectoryInfo(UI.UserPath + "\\attach_temp");

        if (di.Exists)
        {
            di.Delete(true);
            di.Create();
        }
        di = new DirectoryInfo(UI.UserPath + "\\cid_temp");

        if (di.Exists)
        {
            di.Delete(true);
            di.Create();
        }

        //2010.07.29추가 전체저장 폴더 삭제.
        di = new DirectoryInfo(UI.UserPath + "\\allfile_temp");

        if (di.Exists)
        {
            di.Delete(true);
            di.Create();
        }
    }
    #endregion

    #region POP3로 가져오다가 에러난 메일 처리하는 루틴
    /// <summary>
    /// POP3로 가져오다가 에러난 메일 처리하는 루틴
    /// </summary>
    /// <param name="strUserId"></param>
    /// <param name="strDomain"></param>
    private void ProcErrorMail(string strUserId, string strDomain)
    {
        DirectoryInfo di = new DirectoryInfo(UI.UserPath + "\\error");
        string strMsg = "";

        if (di.Exists)
        {
            Passkorea.DbMail.DbMail dbMail = new Passkorea.DbMail.DbMail();

            foreach (FileInfo file in di.GetFiles("*.eml"))
            {
                dbMail.DbCon = strCon;
                dbMail.UserId = strUserId;
                dbMail.Domain = strDomain;
                dbMail.MailboxIdx = 1;
                dbMail.MailFilePath = file.FullName;

                if (dbMail.InsertDbMail(UI.UserPath))
                {
                    // 처리가 완료되면 파일을 Error 폴더에서 지정된 폴더로 이동
                    if (!Directory.Exists(dbMail.MoveMailBox))
                        Directory.CreateDirectory(dbMail.MoveMailBox);

                    try
                    {
                        File.Move(file.FullName, dbMail.MoveMailBox + "\\" + dbMail.MoveMailFile);
                    }
                    catch
                    {
                        if (!Directory.Exists(UI.UserPath + "\\Error"))
                            Directory.CreateDirectory(UI.UserPath + "\\Error");

                        File.Move(file.FullName, UI.UserPath + "\\Error\\" + file.Name);

                        if (!File.Exists(UI.UserPath + "\\Error\\ReportErrorMail.txt"))
                            File.Create(UI.UserPath + "\\Error\\ReportErrorMail.txt").Close();

                        FileStream fs = new FileStream(UI.UserPath + "\\Error\\ReportErrorMail.txt", FileMode.Append, FileAccess.Write);
                        StreamWriter sw = new StreamWriter(fs, System.Text.Encoding.Default);

                        strMsg = file.Name + " 파일이 " + dbMail.MoveMailBox + " 폴더에 존재합니다. 메일파일 이동작업을 취소합니다.\r\n\r\n";

                        sw.Write(strMsg);
                        sw.Close();
                        fs.Close();
                    }
                }
                else
                {
                    if (!dbMail.ExistsMail)
                    {
                        // DB에 존재하지 않는 메일이 에러 발생한 경우 Error 폴더를 생성하고 그안에 로그를 남긴다.
                        if (!Directory.Exists(UI.UserPath + "\\Error"))
                            Directory.CreateDirectory(UI.UserPath + "\\Error");

                        File.Move(file.FullName, UI.UserPath + "\\Error\\" + file.Name);

                        if (!File.Exists(UI.UserPath + "\\Error\\ReportErrorMail.txt"))
                            File.Create(UI.UserPath + "\\Error\\ReportErrorMail.txt").Close();

                        FileStream fs = new FileStream(UI.UserPath + "\\Error\\ReportErrorMail.txt", FileMode.Append, FileAccess.Write);
                        StreamWriter sw = new StreamWriter(fs, System.Text.Encoding.Default);

                        strMsg = "[" + DateTime.Now.ToString() + "]\t" + file.Name + "\t" + dbMail.ErrorMessage + "\r\n\r\n";
                        
                        sw.Write(strMsg);
                        sw.Close();
                        fs.Close();

                        if (dbMail.ProcessState == -3)
                            break;
                    }
                    else
                        File.Delete(file.FullName);
                }
            }
        }
    }
    #endregion

    #region 보관기간 지난 메일 삭제 루틴
    /// <summary>
    /// 보관기간 지난 메일 삭제 루틴
    /// </summary>
    /// <param name="strUserId"></param>
    /// <param name="strDomain"></param>
    private void ProcAutoDeleteMail(string strUserId, string strDomain)
    {
        try
        {
            if (Con == null)
                Con = new OleDbConnection(strCon);

            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception e)
        {
            JS.MessageBox("보관기간 지난 메일 삭제 DB Open 오류\r\n" + e.Message);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandTimeout = 60;
            Cmd.CommandText = "prAutoDeleteListMail";

            Cmd.Parameters.Clear();

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@strUserId"].Value = strUserId;
            Cmd.Parameters["@strDomain"].Value = strDomain;

            OleDbDataReader reader = Cmd.ExecuteReader();

            if (reader.HasRows)
            {
                while (reader.Read())
                {
                    string mailboxNo = reader["Mc_Mailbox_No"].ToString();
                    string mailfile = reader["Mc_Filename"].ToString();
                    
                    if (File.Exists(UI.UserPath + "\\" + mailboxNo + "\\" + mailfile))
                        File.Delete(UI.UserPath + "\\" + mailboxNo + "\\" + mailfile);
                }
            }

            reader.Close();
            
            Trans.Commit();
        }
        catch (Exception e)
        {
            Trans.Rollback();
            Con.Close();
            JS.MessageBox("보관기간 지난 메일 삭제 오류\r\n" + e.Message);
            return;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }
    }
    #endregion

    //2011.05.18 기간이 지난 대용량 첨부 파일 삭제 한다.
    #region 기간이 지난 대용량 첨부 파일 삭제 한다.
    public void BigFileDelete(string id, string domain, string strcon)
    {
        //폳더를 삭제 한다.
        OleDbConnection Conn = new OleDbConnection(strCon);

        string strSql = "select File_Path,USER_ID from BIG_MAIL_Filedown_Limit where " +
                        "USER_ID = '" + id + "' and User_Domain='" + domain + "' and Is_Download = 'N' group by File_Path ,USER_ID";

        OleDbDataAdapter Adapter = new OleDbDataAdapter(strSql, Conn);

        DataSet ds = new DataSet();
        DataTable dt = new DataTable();

        try
        {
            // 데이터 어댑터를 사용해서 데이터 셋에 데이터를 채운다.
            Adapter.Fill(ds, "BIG_MAIL_Filedown_Limit");
            // 데이터 셋에 있는 데이터를 테이블만 데이터 테이블 객체로 옮긴다.
            dt = ds.Tables["BIG_MAIL_Filedown_Limit"];

            // 데이터가 있으면 해당 데이터를 각 필드에 넣는다.
            if (dt.Rows.Count > 0)
            {
                string temp = "";

                foreach (DataRow dr in dt.Rows)
                {
                    string file_path = dr["File_Path"].ToString();

                    DirectoryInfo di = new DirectoryInfo(strDefaultBigFilePath + "\\" + domain + "\\Big_File_Data\\" + id + file_path);

                    try
                    {
                        if (di.Exists)
                        {
                            di.Delete(true);
                        }
                    }
                    catch (Exception exx)
                    {
                        JS.MessageBox("기한이 지난 대용량 파일 삭제 중 애러");
                    }

                }

                Conn.Close();
            }
        }
        catch (Exception ex)
        { }
    }

    #endregion

    private string EncodingMD5(string strValue)
    {
        MD5 md5Hasher = MD5.Create();
        byte[] encData = md5Hasher.ComputeHash(Encoding.Default.GetBytes(strValue));
        StringBuilder sb = new StringBuilder(32);

        for (int iLoop = 0; iLoop < encData.Length; iLoop++)
            sb.Append(encData[iLoop].ToString("x2"));

        return sb.ToString();
    }

    public string ErrMsg
    {
        get { return strErrMsg; }
        set { strErrMsg = value; }
    }
}
