﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MailParse;
using Passkorea.MIME;

public partial class Mail_ListMail : System.Web.UI.Page
{
    protected System.Web.UI.WebControls.Label lblMailId;

    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter Param = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private UserInfo UI;
    private WebFunction WF;
    private JavaScript JS;
    private string strDemo = ConfigurationSettings.AppSettings["strDemo"];
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strMovePage = "";
    private string mailFilePath = "";

    //2010.03.22 private에서 protected로 수정함.
    protected string strListCount = "";

    private string strStartDate = "";
    private string strEndDate = "";
    protected int iMailCount = 0;

    protected string strDomain = "";
    protected string strUserId = "";
    protected string strPage = "";
    protected string strMailBox = "";
    protected string strMailBoxName = "";
    protected string strPageLink = "";
    protected string strMailNameTag = "";
    protected string strMsgMailCount = "";
    protected string strSchType = "";
    protected string strSchValue = "";

    //2010.01.28 추가
    //기간 라디오버튼 속성 받아올 변수 추가
    protected string strSchRType = "";

    //2010.03.22
    //읽지않은 편지만 가져 오기위해 변수 추가.
    protected string strIs_Read = "";

    protected string strdiv = "";


    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        string strScript = "";

        JS = new JavaScript(this.Page);
        JS.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);
        WF = new WebFunction();

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        JS.LodingPage("메일 목록을 가져오고 있습니다.");

        strUserId = Session["USER_ID"].ToString();
        strMailBox = Request.Params["mailbox"];
        strSchType = WF.StringDefaultValue(Request.Params["schType"], "");
        strSchValue = WF.StringDefaultValue(Request.Params["schValue"], "");
        strStartDate = WF.StringDefaultValue(Request.Params["startDate"], "");
        strEndDate = WF.StringDefaultValue(Request.Params["endDate"], "");
        strPage = Request.Params["iPage"];
        strListCount = Request.Params["listCnt"];
        mailFilePath = UI.UserPath;
        strMovePage = Request.PhysicalPath;

        //2010.01.28 추가
        strSchRType = WF.StringDefaultValue(Request.Params["strSchRTtpe"], "");

        //2010.03.22 추가
        strIs_Read = WF.StringDefaultValue(Request.Params["strIs_Read"], "");

        if (strMailBox == "" || strMailBox == null) strMailBox = "1";

        if (!Page.IsPostBack)
        {
            //2010.01.28  기간을 정했을 경우
            if (strSchType != "")
            {
                //구분
                ddlSearchType.SelectedIndex = int.Parse(strSchType);
                //내용
                tbSearchValue.Text = strSchValue;
                //기간
                if (strSchRType != "")
                {
                    rblSearchPeriod.SelectedIndex = int.Parse(strSchRType);
                }
                //시작일
                tbStartPeriod.Text = strStartDate;
                //끝
                tbEndPeriod.Text = strEndDate;

            }
            this.MailBoxDataBind();
            this.MailboxLink(strMailBox);
            this.MailBoxNameBind();

            if (strMailBox.ToLower() == "201")
                ibRestoreMail.Visible = true;

            if (strMailBox.ToLower() == "101" || strMailBox.ToLower() == "301")
                strMailNameTag = "받는이";
            else
                strMailNameTag = "보낸이";

            try
            {
                if (strListCount != "" && strListCount != null)
                {
                    if (int.Parse(strListCount) > 60)
                        strListCount = "60";

                    ddlListCount.SelectedValue = strListCount;
                }
            }
            catch
            {
                ddlListCount.SelectedIndex = 0;
            }

            this.GetMailList();
            //this.MailDataBind();
            Page.DataBind();
        }

        //2001.02.01 수정
        // 보낸 편지한 또는 임시 저장함 일때 수신거부 버튼 비활성화
        //if (strMailBox.Equals("101") || strMailBox.Equals("401"))
        //    AnchorRejectMail.Visible = false;

        if (strDemo.ToLower() == "yes")
            strScript = "alert('데모라서 메일삭제가 되지 않습니다.'); return false;";
        else
            strScript = "if (!SelectMail('삭제', false)) return false; else return true;";

        // 메일 삭제버튼 속성 추가
        if (strMailBox == "201")
            ibDeleteMail.Attributes.Add("onclick", strScript);

        //2001.02.01 수정
        //// 메일 백업버튼 속성 추가
        //strScript = "if (!SelectMail('백업', true)) return false; else return true;";
        //ibMailBackup.Attributes.Add("onclick", strScript);

        // 메일 이동버튼 속성 추가
        strScript = "if (!MoveMail()) return false; else return true;";
        ibMoveMail.Attributes.Add("onclick", strScript);

        // 메일 상세 검색
        strScript = "if (!DetailMailSearch()) return false; else return true;";
        ibDetailSearch.Attributes.Add("onclick", strScript);

        //2010.01.28 추가 기간라이오 버튼 속성 추가
        rblSearchPeriod.Attributes.Add("onClick", "return selectdate()");

        JS.EndLodingPage();
    }

    private void MailboxLink(string mailboxIdx)
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception e)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" + e.Message);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prLoadParentMailbox";

            Cmd.Parameters.Clear();

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Cmd.Parameters.Add("@strUserId", OleDbType.VarChar).Value = strUserId;
            Cmd.Parameters.Add("@strDomain", OleDbType.VarChar).Value = strDomain;
            Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt).Value = int.Parse(mailboxIdx);

            OleDbDataReader reader = Cmd.ExecuteReader();

            if (reader.HasRows)
            {
                reader.Read();

                string mailboxName = reader["M_Mailbox_Name"].ToString();
                string strMailboxIdx = reader["M_Idx"].ToString();

                reader.Close();
                Con.Close();

                if (mailboxIdx != strMailboxIdx)
                {
                    mailboxName = "<a href=\"ListMail.aspx?mailbox=" + strMailboxIdx + "\">" + mailboxName + "</a>";
                    strMailBoxName = mailboxName + " > " + strMailBoxName;
                    MailboxLink(strMailboxIdx);
                }
            }
            else
                reader.Close();
        }
        catch (Exception e)
        {
            Con.Close();
            JS.MessageBox(e.Message);
            return;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }
    }

    #region 메일박스 데이터 바인드
    private void MailBoxDataBind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" + err.Message);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMailBox";

            Cmd.Parameters.Clear();

            Cmd.Parameters.Add("@varUserId", OleDbType.VarChar).Value = strUserId;
            Cmd.Parameters.Add("@varDomain", OleDbType.VarChar).Value = strDomain;
            Cmd.Parameters.Add("@strIsDefault", OleDbType.Char).Value = "";
            Cmd.Parameters.Add("@strIsMainView", OleDbType.Char).Value = "";


            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_BOX");
            dt = ds.Tables["MAIL_BOX"];

            foreach (DataRow dr in dt.Rows)
            {
                int iDepth = int.Parse(dr["M_Depth"].ToString());
                string strIdx = dr["M_Idx"].ToString();
                string strBoxName = dr["M_MAILBOX_NAME"].ToString();

                if (iDepth > 0)
                {
                    strBoxName = "┗" + strBoxName;
                    for (int i = 0; i < iDepth; i++)
                        strBoxName = Server.HtmlDecode("&nbsp;") + strBoxName;
                }

                ListItem li = new ListItem(strBoxName, strIdx);
                ddlMailBoxList.Items.Add(li);
                ddlSearchMailbox.Items.Add(li);

            }

            if (strMailBox.Trim() != "")
                ddlSearchMailbox.SelectedValue = strMailBox;

            ListItem li2 = new ListItem("모든편지함", "0");
            ddlSearchMailbox.Items.Add(li2);


            ddlSearchMailbox.DataBind();
            ddlMailBoxList.DataBind();
        }
        catch (Exception err)
        {
            Con.Close();
            JS.MessageBox("편지함 정보를 가져오는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            return;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }
    }
    #endregion

    #region 메일 리스트
    /// <summary>
    /// 메일 리스트 출력
    /// </summary>
    private void GetMailList()
    {
        int intPageCount = int.Parse(ConfigurationSettings.AppSettings["intPageCount"]);
        // 2006년 11월 27일 수정
        // 메일 출력 갯수를 DropDownList에 설정
        int intListCount = int.Parse(ddlListCount.SelectedValue);
        int iPage = 0;
        int totalPage = 0;
        int modPage = 0;
        int iNoReadCount = 0;
        int iCnt = 0;
        int iLoop = 0;
        int iRowCnt = 0;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();

            strMovePage = strMovePage.Substring(strMovePage.LastIndexOf("\\") + 1);
        }
        catch (Exception e)
        {
            JS.MessageBox(e.Message);
            return;
        }

        try
        {
            if (strPage == null)
                iPage = 1;
            else
            {
                if (strPage == "")
                    iPage = 1;
                else
                    iPage = int.Parse(strPage);
            }

            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMail";

            Cmd.Parameters.Clear();

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Cmd.Parameters.Add("@strUserId", OleDbType.VarChar).Value = strUserId;
            Cmd.Parameters.Add("@strDomain", OleDbType.VarChar).Value = strDomain;
            Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt).Value = int.Parse(strMailBox);
            Cmd.Parameters.Add("@strSearchType", OleDbType.VarChar).Value = strSchType;
            Cmd.Parameters.Add("@strSearchValue", OleDbType.VarWChar).Value = strSchValue;
            Cmd.Parameters.Add("@strStartDate", OleDbType.VarChar).Value = strStartDate;
            Cmd.Parameters.Add("@strEndDate", OleDbType.VarChar).Value = strEndDate;
            Cmd.Parameters.Add("@iPage", OleDbType.Integer).Value = iPage;
            Cmd.Parameters.Add("@iPageSize", OleDbType.Integer).Value = intListCount;
            Cmd.Parameters.Add("@strIs_Read", OleDbType.VarChar).Value = strIs_Read;

            Param = Cmd.Parameters.Add("@iTotalCount", OleDbType.Integer);
            Param.Direction = ParameterDirection.Output;

            Param = Cmd.Parameters.Add("@iNoReadCount", OleDbType.Integer);
            Param.Direction = ParameterDirection.Output;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "NM_MAIL_CONTENT");
            dt = ds.Tables["NM_MAIL_CONTENT"];

            int iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());

            if (iResult != 0)
            {
                return;
            }

            if (dt != null)
                iRowCnt = dt.Rows.Count;
            else
            {
                dt = new DataTable();
                iRowCnt = 0;
            }

            iMailCount = int.Parse(Cmd.Parameters["@iTotalCount"].Value.ToString());
            iNoReadCount = int.Parse(Cmd.Parameters["@iNoReadCount"].Value.ToString());


            //2010.03.22 읽지않은 편지만 가져 오기 위해서 수정함.
            if (iNoReadCount == 0)
                strMsgMailCount = "※ 전체: <b><font color=\"red\">" + iMailCount.ToString() + "</font></b> 통 / 읽지않은 편지: <b> <font color=\"Blue\">" + iNoReadCount.ToString() + "</a></font></b>통";
            else
                strMsgMailCount = "※ 전체: <b><font color=\"red\">" + iMailCount.ToString() + "</font></b> 통 / 읽지않은 편지: <b> <a href=\"ListMail.aspx?mailbox=" + Server.UrlEncode(strMailBox) + "&listCnt=" + intListCount + "&schType=" + strSchType +
                    "&schValue=" + Server.UrlEncode(strSchValue) + "&startDate=" + strStartDate + "&endDate=" + strEndDate + "&strSchRTtpe=" + strSchRType + "&strIs_Read=0\"><font color=\"Blue\">" + iNoReadCount.ToString() + "</a></font></b>통";


            //2010.03.22
            //페이지 수를 계산할때 전체 갯수는 읽지않은 메일만 이기 때문에 로직 수정함.
            if (strIs_Read == "0")
                iMailCount = int.Parse(Cmd.Parameters["@iNoReadCount"].Value.ToString());
            else
                iMailCount = int.Parse(Cmd.Parameters["@iTotalCount"].Value.ToString());

            //2011.04.04 추가
            this.hidicnt.Value = iMailCount.ToString();

            // 전체 페이지
            totalPage = iMailCount / intListCount;
            // 나머지 페이지
            modPage = iMailCount % intListCount;

            // 나머지 페이지가 0이 아니면 전체 페이지에 1을 더한다.
            // 그러면 전체 페이지가 나온다.
            if (modPage > 0)
                ++totalPage;

            if (iRowCnt > 0)
            {

                string[,] strMail = new string[iRowCnt, 14];

                foreach (DataRow dr in dt.Rows)
                {
                    strMail[iCnt, 0] = dr["Mc_Idx"].ToString();
                    strMail[iCnt, 1] = dr["Mc_Subject"].ToString();
                    strMail[iCnt, 2] = dr["Mc_From"].ToString();
                    strMail[iCnt, 3] = dr["Mc_To"].ToString();
                    strMail[iCnt, 4] = dr["Mc_Receive_Date"].ToString();
                    strMail[iCnt, 5] = dr["Mc_Attach_Count"].ToString();
                    strMail[iCnt, 6] = dr["Mc_Is_Read"].ToString();
                    strMail[iCnt, 7] = dr["Mc_Read_Date"].ToString();
                    strMail[iCnt, 8] = dr["Mc_Is_Forward"].ToString();
                    strMail[iCnt, 9] = dr["Mc_Forward_Date"].ToString();
                    strMail[iCnt, 10] = dr["Mc_Is_Reply"].ToString();
                    strMail[iCnt, 11] = dr["Mc_Reply_Date"].ToString();
                    strMail[iCnt, 12] = dr["Mc_Size"].ToString();
                    strMail[iCnt, 13] = dr["MC_Mailbox_idx"].ToString();

                    iCnt++;
                }

                dt.Rows.Clear();
                dt.Columns.Clear();

                dt.Columns.Add("mailId", System.Type.GetType("System.String"));
                dt.Columns.Add("mailSubject", System.Type.GetType("System.String"));
                dt.Columns.Add("mailAddr", System.Type.GetType("System.String"));
                dt.Columns.Add("mailDate", System.Type.GetType("System.String"));
                dt.Columns.Add("attachfile", System.Type.GetType("System.String"));
                dt.Columns.Add("mailForwardNRject", System.Type.GetType("System.String"));
                dt.Columns.Add("mailSize", System.Type.GetType("System.String"));

                for (iLoop = 0; iLoop < iCnt; iLoop++)
                {
                    DataRow dr = dt.NewRow();
                    string strForwardReply = "";

                    // 메일 아이디값
                    dr["mailId"] = strMail[iLoop, 0];
                    // 받은시간
                    DateTime date = DateTime.Parse(strMail[iLoop, 4]);

                    if (DateTime.Now.ToString("yyyy-MM-dd") == date.ToString("yyyy-MM-dd"))
                        dr["mailDate"] = date.ToString("HH:mm:ss");
                    else
                        dr["mailDate"] = date.ToString("yyyy-MM-dd");

                    // 제목
                    if (strMail[iLoop, 1].Trim() == "")
                        strMail[iLoop, 1] = "제목이 없습니다 .";
                    else
                    {
                        if (strMail[iLoop, 1].Length > 56)
                            strMail[iLoop, 1] = strMail[iLoop, 1].Substring(0, 56) + "...";

                        strMail[iLoop, 1] = strMail[iLoop, 1].Replace("<", "&lt;");
                    }

                    // 읽음 읽지 않음 여부 표시
                    if (strMail[iLoop, 6].ToString() == "False")
                        strMail[iLoop, 1] = "<b>" + strMail[iLoop, 1] + "</b>";

                    // outbox일때는 받는사람, 그이외에는 모두 보낸 사람
                    if (strMailBox.ToLower() == "101" || strMailBox.ToLower() == "301")
                    {

                        string[] arrTmp = WF.linkMailAddress2(strMail[iLoop, 3], "writeMail.aspx?email=", 15, "...");
                        dr["mailAddr"] = arrTmp[0];
                    }
                    else
                    {
                        string[] arrTmp = WF.linkMailAddress(strMail[iLoop, 2], "writeMail.aspx?email=", 15, "...");
                        dr["mailAddr"] = arrTmp[0];
                    }

                    if (dr["mailAddr"].ToString().Trim() == "")
                        dr["mailAddr"] = "&nbsp;";

                    //2010.03.22 수정. 상세검색에서 모든편지함검색을 포함하기 위해서 수정함.
                    // 임시저장함일때 제목 링크를 편지쓰기로 지정한다.
                    //if (strMailBox.ToLower() == "301")
                    //    dr["mailSubject"] = "<a href=\"writeMail.aspx?MailBox=" + Server.UrlEncode(strMailBox) + "&mailId=" + strMail[iLoop, 0] + "\">" + strMail[iLoop, 1] + "</a>";
                    //else
                    //    dr["mailSubject"] = "<a href=\"viewMail.aspx?MailBox=" + Server.UrlEncode(strMailBox) + "&mailId=" + strMail[iLoop, 0] + "&iPage=" + iPage + "\">" + strMail[iLoop, 1] + "</a>";

                    if (strMailBox.ToLower() == "301")
                        //2011.09.16 임시편지함 리스트에 Savetype=1 붙도록 수정함.
                        dr["mailSubject"] = "<a href=\"writeMail.aspx?MailBox=" + strMail[iLoop, 13] + "&mailId=" + strMail[iLoop, 0] + "&Savetype=1\">" + strMail[iLoop, 1] + "</a>";
                    else
                        dr["mailSubject"] = "<a href=\"viewMail.aspx?MailBox=" + strMail[iLoop, 13] + "&mailId=" + strMail[iLoop, 0] + "&iPage=" + iPage + "\">" + strMail[iLoop, 1] + "</a>";

                    // 첨부파일이 존재할 경우에 이미지를 붙여준다.
                    if (int.Parse(strMail[iLoop, 5]) > 0)
                        dr["attachfile"] = "<img src=\"../Images/Icon/attach.gif\">";
                    else
                        dr["attachfile"] = "&nbsp;";

                    // 전달 또는 답변 또는 전달/답변 일때 이미지를 붙인다.
                    if (strMail[iLoop, 10].ToLower() == "true")
                        strForwardReply = "<img src=\"../Images/icon_check.gif\" alt=\"답변시각: " + strMail[iLoop, 11] + "\">";

                    if (strMail[iLoop, 8].ToLower() == "true")
                    {
                        if (strForwardReply.Trim() != "")
                            strForwardReply += "/";

                        strForwardReply += "<img src=\"../Images/icon_reply.gif\" alt=\"전달시각: " + strMail[iLoop, 9] + "\">";
                    }

                    dr["mailForwardNRject"] = strForwardReply;

                    dr["mailSize"] = WF.GetFileSize(long.Parse(strMail[iLoop, 12]));

                    dt.Rows.Add(dr);
                }
            }

            rptMailList.DataSource = dt.DefaultView;
            rptMailList.DataBind();

            //2013.06.20 전체 페이지 저장
            this.hiditotcnt.Value = totalPage.ToString();

            //2010.03.22 뒤에  + "&strIs_Read" + strIs_Read; 추가
            //2010.01.28 뒤에 + "&strSchRTtpe=" + strSchRType 추가했음
            string args = "&mailbox=" + Server.UrlEncode(strMailBox) + "&listCnt=" + intListCount + "&schType=" + strSchType +
                "&schValue=" + Server.UrlEncode(strSchValue) + "&startDate=" + strStartDate + "&endDate=" + strEndDate + "&strSchRTtpe=" + strSchRType + "&strIs_Read=" + strIs_Read;

            lblPageLink.Text = WF.PageLink(totalPage, iPage, strMovePage, args, 10, "", "", "", "");
        }
        catch (Exception e)
        {
            Con.Close();
            JS.MessageBox(e.Message);
            return;
        }
        finally
        {
            if (Con.State == ConnectionState.Closed)
                Con.Close();
        }
    }
    #endregion

    #region 메일박스 이름
    private void MailBoxNameBind()
    {
        try
        {
            strMailBox = strMailBox.ToLower();

            if (strMailBox == "1")
                lblMailBox.Text = "<b>받은편지함</b>";
            else if (strMailBox == "101")
                lblMailBox.Text = "<b>보낸편지함</b>";
            else if (strMailBox == "201")
                lblMailBox.Text = "<b>지운편지함</b>";
            else if (strMailBox == "301")
                lblMailBox.Text = "<b>임시저장함</b>";
            else if (strMailBox == "401")
                lblMailBox.Text = "<b>스팸편지함</b>";
            //2010.03.22 모든편지함 검색을 위해 추가함.
            else if (strMailBox == "0")
                lblMailBox.Text = "<b>모든편지함</b>";
            else
            {//2011.8.12 추가 원래 있던 ds.tables가 아닌 새로운 ds.tables를 만듬.
                try
                {
                    Con = new OleDbConnection(strCon);
                    Con.Open();
                }
                catch (Exception err)
                {
                    JS.MessageBox("DB Connection Fail!!!\r\n" + err.Message);
                    return;
                }

                try
                {
                    Cmd.Connection = Con;
                    Cmd.CommandType = CommandType.StoredProcedure;
                    Cmd.CommandText = "prListMailBox";

                    Cmd.Parameters.Clear();

                    Cmd.Parameters.Add("@varUserId", OleDbType.VarChar).Value = strUserId;
                    Cmd.Parameters.Add("@varDomain", OleDbType.VarChar).Value = strDomain;
                    Cmd.Parameters.Add("@strIsDefault", OleDbType.Char).Value = "";
                    Cmd.Parameters.Add("@strIsMainView", OleDbType.Char).Value = "";

                    Adap.Dispose();
                    Adap = new OleDbDataAdapter(Cmd);
                    Adap.Fill(ds, "MAIL_BOX");
                    dt = ds.Tables["MAIL_BOX"];

                    foreach (DataRow dr in dt.Rows)
                    {

                        if (strMailBox == dr["M_Idx"].ToString().ToLower())
                        {
                            strMailBoxName += "<b>" + dr["M_MAILBOX_NAME"].ToString() + "</b>";
                            break;
                        }
                    }
                }
                catch (Exception err)
                {
                    Con.Close();
                    JS.MessageBox("편지함 정보를 가져오는 도중 오류가 발생했습니다.\r\n" +
                        err.Message);
                    return;
                }
                finally
                {
                    if (Con.State != ConnectionState.Closed)
                        Con.Close();
                }
            }
            /*
            else
            {
                dt = ds.Tables["MAIL_BOX"];

                int iRowCount = dt.Rows.Count;

                if (iRowCount > 0)
                {
                    for (int iLoop = 0; iLoop < iRowCount; iLoop++)
                    {
                        DataRow dr = dt.Rows[iLoop];
                        if (strMailBox == dr["M_Idx"].ToString().ToLower())
                        {
                            strMailBoxName += "<b>" + dr["M_MAILBOX_NAME"].ToString() + "</b>";
                            break;
                        }

                    }
                }
            }
            */

            if (strMailBoxName.Trim() != "")
                lblMailBox.Text = strMailBoxName;
        }
        catch (Exception err)
        {
            JS.MessageBox("메일 박스 이름을 표시하는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            return;
        }
    }
    #endregion

    #region 선택한 메일 백업
    /*
    protected void ibMailBackup_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strMailId = hidMailId.Value;
        string strCompressFile = "";
        bool bFile = false;

        if (strMailId == "")
        {
            JS.MessageBox("백업할 메일을 선택해 주세요.");
            JS.MovePage("ListMail.aspx?mailbox=" + strMailBox);
            return;
        }

        // 백업할 파일명을 사용자 아이디 + Sel + 메일박스 명으로 백업한다.
        strCompressFile = strUserId + "_" + DateTime.Now.ToString("yyyyMMdd") + "_" + strMailBox + ".zip";

        if (strMailId != "")
        {
            try
            {
                Con = new OleDbConnection(strCon);
                Con.Open();
            }
            catch (Exception err)
            {
                JS.MessageBox(err.Message);
                return;
            }

            try
            {
                strMailId = strMailId.Replace("|", ",");

                if (strMailId.EndsWith(","))
                    strMailId = strMailId.Substring(0, strMailId.Length - 1);

                Cmd.Connection = Con;
                Cmd.CommandType = CommandType.StoredProcedure;
                Cmd.CommandText = "prSelectMailFile";

                Cmd.Parameters.Clear();

                Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
                Param.Direction = ParameterDirection.ReturnValue;

                Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strMailIdx", OleDbType.VarChar, strMailId.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
                Param.Direction = ParameterDirection.Input;

                Cmd.Parameters["@strUserId"].Value = strUserId;
                Cmd.Parameters["@strDomain"].Value = strDomain;
                Cmd.Parameters["@strMailIdx"].Value = strMailId;
                Cmd.Parameters["@iMailboxIdx"].Value = int.Parse(strMailBox);

                Adap = new OleDbDataAdapter(Cmd);
                Adap.Fill(ds, "NM_MAIL_LIST");
                dt = ds.Tables["NM_MAIL_LIST"];

                if (dt != null)
                {
                    // 압축을 하기위에 자바 라이브러리에 포함되어 있는 Zip 압축 관련 라이브러리를 끌어쓴다.
                    // 단, 자바 라이브러리를 사용하기 위해서는 MS Visual J# .Net 재배포 패키지를 설치해야
                    // 자바 라이브러리를 사용할 수 있다.
                    java.io.FileOutputStream fos = new java.io.FileOutputStream(UI.UserPath + "\\" + strCompressFile);
                    java.util.zip.ZipOutputStream zos = new java.util.zip.ZipOutputStream(fos);

                    foreach (DataRow dr in dt.Rows)
                    {
                        string filePath = UI.UserPath + "\\" + dr["Mc_Mailbox_No"].ToString();
                        string filename = dr["Mc_Filename"].ToString();

                        if (File.Exists(filePath + "\\" + filename))
                        {
                            bFile = true;
                            java.io.FileInputStream fis = new java.io.FileInputStream(filePath + "\\" + filename);
                            java.util.zip.ZipEntry ze = new java.util.zip.ZipEntry(filename);
                            zos.putNextEntry(ze);

                            sbyte[] buf = new sbyte[1024];
                            int len = 0;

                            while ((len = fis.read(buf)) >= 0)
                                zos.write(buf, 0, len);

                            zos.closeEntry();
                            fis.close();
                        }
                    }

                    zos.close();
                    fos.close();

                    if (!bFile)
                        File.Delete(UI.UserPath + "\\" + strCompressFile);
                }
            }
            catch (Exception err)
            {
                Con.Close();
                JS.MessageBox("선택한 편지를 백업하는 도중 오류가 발생했습니다.\r\n" +
                    "서버관리자에게 문의 하세요.\r\n" + err.Message);
                return;
            }
            finally
            {
                if (Con.State != ConnectionState.Closed)
                    Con.Close();
            }

            if (bFile)
            {
                FileInfo f = new FileInfo(UI.UserPath + "\\" + strCompressFile);

                Response.Clear();
                Response.ClearContent();
                Response.ContentType = "Application/Octet-stream";
                Response.AddHeader("Content-Disposition", "attachment; filename=" + strCompressFile);
                Response.WriteFile(f.FullName);
                Response.End();
            }
            else
            {
                JS.MessageBox("선택한 메일에 대한 원문이 존재하지 않아서 메일을 백업할수 없습니다.");
                JS.HistoryBack();
                Response.End();
            }
        }
    }
    */
    #endregion

    #region 선택한 메일 복원
    protected void ibRestoreMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strMailId = hidMailId.Value;

        if (strMailId == "")
        {
            JS.MessageBox("복원할 메일을 선택해 주세요.");
            JS.MovePage("ListMail.aspx?mailbox=" + strMailBox);
            return;
        }
        else if (strMailId != "")
        {
            strMailId = strMailId.Replace("|", ",");

            if (strMailId.EndsWith(","))
                strMailId = strMailId.Substring(0, strMailId.Length - 1);

            if (strMailBox == "201")
            {
                try
                {
                    if (!MoveMail("1", strMailId))
                        return;
                }
                catch (Exception err)
                {
                    JS.MessageBox("선택한 메일을 복구 하는 도중 오류가 발생했습니다.\r\n" +
                        "관리자에게 문의하세요.\r\n" + err.Message);
                    return;
                }

            }
            JS.MessageBox("선택한 메일을 복원 하였습니다.");
            JS.MovePage("ListMail.aspx?mailbox=" + strMailBox);
            return;
        }
    }
    #endregion

    #region 선택한 메일 삭제
    protected void ibDeleteMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strMailId = hidMailId.Value;

        int iPage = 0;
        int iListCount = 0;

        if (strMailId == "")
        {
            JS.MessageBox("삭제할 메일을 선택해 주세요.");
            JS.MovePage("ListMail.aspx?mailbox=" + strMailBox);
            return;
        }

        if (strMailId != "")
        {
            try
            {
                Con = new OleDbConnection(strCon);
                Con.Open();
                Trans = Con.BeginTransaction();
            }
            catch (Exception err)
            {
                JS.MessageBox(err.Message);
                return;
            }

            strMailId = strMailId.Replace("|", ",");

            if (strMailId.EndsWith(","))
                strMailId = strMailId.Substring(0, strMailId.Length - 1);

            //2011.04.04 카운트 부분 추가함
            iMailCount = int.Parse(this.hidicnt.Value) - strMailId.Split(',').Length;

            //2013.06.20 마지막 페이지에 갯수가 안맞을때 오류가 나는 부분이 있어서 수정함.
            if (strPage == null)
                iPage = 1;
            else
            {
                if (strPage == "")
                    iPage = 1;
                else
                    iPage = int.Parse(strPage);
            }

            if (strListCount == null)
                iListCount = int.Parse(ddlListCount.SelectedValue);
            else
            {
                if (strListCount == "")
                    iListCount = int.Parse(ddlListCount.SelectedValue);
                else
                    iListCount = int.Parse(strListCount);
            }


            //현재 페이지에서 마지막 페이지인지 확인후. 마지막 페이지인경우 마지막 페이지 갯수와 전체선택시 클릭된 갯수를 비교함.
            if (iPage.ToString() == this.hiditotcnt.Value)
            {
                int itemp = int.Parse(this.hidicnt.Value) - (iListCount * (iPage - 1));

                if (itemp < strMailId.Split(',').Length)
                    iPage--;
                else
                {
                    int iMod = iMailCount % iListCount;

                    if (iMod == 0)
                        iPage--;
                }
            }
            else
            {
                int iMod = iMailCount % iListCount;

                if (iMod == 0)
                    iPage--;
            }

            if (iPage <= 0)
                iPage = 1;

            strPage = iPage.ToString();
            //2013.06.20 여기까지


            try
            {
                Cmd.Connection = Con;
                Cmd.Transaction = Trans;
                Cmd.CommandType = CommandType.StoredProcedure;
                //2014. 05. 13 보낸편지함에서 삭제시 지운편지함으로 이동하도록 변경함.
                if (strMailBox == "201")//|| strMailBox == "101")
                {
                    string[] mailId = strMailId.Split(',');



                    Cmd.CommandText = "prDeleteMail";

                    Cmd.Parameters.Clear();

                    Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
                    Param.Direction = ParameterDirection.ReturnValue;

                    Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
                    Param.Direction = ParameterDirection.Input;

                    Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
                    Param.Direction = ParameterDirection.Input;

                    Param = Cmd.Parameters.Add("@iMcIdx", OleDbType.Integer);
                    Param.Direction = ParameterDirection.Input;

                    Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
                    Param.Direction = ParameterDirection.Output;

                    Param = Cmd.Parameters.Add("@strMailFile", OleDbType.VarChar, 255);
                    Param.Direction = ParameterDirection.Output;

                    //Param = Cmd.Parameters.Add("@strFile_Path", OleDbType.VarChar, 255);
                    //Param.Direction = ParameterDirection.Output;

                    Cmd.Parameters["@strUserId"].Value = strUserId;
                    Cmd.Parameters["@strDomain"].Value = strDomain;

                    for (int i = 0; i < mailId.Length; i++)
                    {
                        Cmd.Parameters["@iMcIdx"].Value = int.Parse(mailId[i].Trim());

                        Cmd.ExecuteNonQuery();

                        int iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());

                        if (iResult != 0)
                        {
                            if (iResult == -1)
                            {
                                Trans.Rollback();
                                Con.Close();
                                JS.MessageBox("사용자 정보가 없습니다.");
                                return;
                            }
                            else if (iResult == -2)
                            {
                                Trans.Rollback();
                                Con.Close();
                                JS.MessageBox(strDomain + " 도메인에 대한 정보가 없습니다.");
                                return;
                            }
                            else if (iResult == -3)
                            {
                                Trans.Rollback();
                                Con.Close();
                                JS.MessageBox("해당 메일에 대한 정보가 없습니다.");
                                return;
                            }
                        }

                        mailId[i] = Cmd.Parameters["@iMailboxIdx"].Value.ToString() + "\\" + Cmd.Parameters["@strMailFile"].Value.ToString();

                        ////09.08.04추가
                        //if (Cmd.Parameters["@strFile_Path"].Value.ToString() != "")
                        //    strbigFiledir = strbigFiledir + Cmd.Parameters["@strFile_Path"].Value.ToString() + ":";

                    }

                    Trans.Commit();

                    for (int i = 0; i < mailId.Length; i++)
                    {
                        if (File.Exists(UI.UserPath + "\\" + mailId[i]))
                            File.Delete(UI.UserPath + "\\" + mailId[i]);
                    }

                    ////09.08.04 추가
                    //if (strbigFiledir.EndsWith(":"))
                    //    strbigFiledir = strbigFiledir.Substring(0, strbigFiledir.Length - 1);

                    //string[] tempbigFiledir = strbigFiledir.Split(':');

                    //for (int j = 0; j < tempbigFiledir.Length; j++)
                    //{
                    //    if (Directory.Exists(UI.BigFilePath+tempbigFiledir[j]))
                    //        Directory.Delete(UI.BigFilePath+tempbigFiledir[j],true);
                    //}



                }
                else
                {
                    // 메일을 delbox로 이동 한다.
                    if (!MoveMail("201", strMailId))
                        return;
                }
            }
            catch (Exception err)
            {
                Trans.Rollback();
                Con.Close();
                JS.MessageBox("메일을 삭제하는 도중 오류가 발생했습니다.\r\n" + err.Message);
                return;
            }
            finally
            {
                if (Con.State != ConnectionState.Closed)
                    Con.Close();
            }

            //2013.06.20 윗부분으로 올렸음
            //if (strPage == null)
            //    iPage = 1;
            //else
            //{
            //    if (strPage == "")
            //        iPage = 1;
            //    else
            //        iPage = int.Parse(strPage);
            //}

            //if (strListCount == null)
            //    iListCount = int.Parse(ddlListCount.SelectedValue);
            //else
            //{
            //    if (strListCount == "")
            //        iListCount = int.Parse(ddlListCount.SelectedValue);
            //    else
            //        iListCount = int.Parse(strListCount);
            //}

            //int iMod = iMailCount % iListCount;
            //int iLastPage = iMailCount / iListCount;

            ////if (iMod == 0)
            ////{

            ////    if (iPage > iLastPage)
            ////        iPage = iLastPage;
            ////    else
            ////        iPage--;
            ////}

            //if (iMod == 0)
            //    iPage--;


            //if (iPage <= 0)
            //    iPage = 1;

            //strPage = iPage.ToString();

            //JS.MessageBox("선택한 메일이 삭제 되었습니다.");
            JS.MovePage("ListMail.aspx?mailbox=" + Server.UrlEncode(strMailBox) + "&iPage=" + strPage + "&listCnt=" + strListCount + "&schType=" + strSchType +
              "&schValue=" + Server.UrlEncode(strSchValue) + "&startDate=" + strStartDate + "&endDate=" + strEndDate + "&strSchRTtpe=" + strSchRType + "&strIs_Read=" + strIs_Read);

            return;
        }
    }
    #endregion

    #region 선택한 메일 이동
    protected void ibMoveMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strMailId = hidMailId.Value;
        string strSelMailbox = ddlMailBoxList.SelectedValue;
        string strSelMailboxName = ddlMailBoxList.SelectedItem.Text;

        //2011.04.04 카운트 부분 추가함
        iMailCount = int.Parse(this.hidicnt.Value);

        if (strMailId == "")
        {
            JS.MessageBox("삭제할 메일을 선택해 주세요.");
            JS.MovePage("ListMail.aspx?mailbox=" + strMailBox);
            return;
        }

        if (strMailId != "")
        {
            strMailId = strMailId.Replace("|", ",");

            if (strMailId.EndsWith(","))
                strMailId = strMailId.Substring(0, strMailId.Length - 1);

            try
            {
                if (!MoveMail(strSelMailbox, strMailId))
                    return;
            }
            catch (Exception err)
            {
                JS.MessageBox("선택한 메일을 " + strSelMailboxName + " 편지함으로 이동 하는 도중 오류가 발생했습니다.\r\n" +
                    err.Message);
                return;
            }
        }

        //JS.MessageBox("선택한 메일을 " + strSelMailboxName + " 편지함으로 이동했습니다.");
        JS.MovePage("ListMail.aspx?mailbox=" + Server.UrlEncode(strMailBox) + "&iPage=" + strPage + "&listCnt=" + strListCount + "&schType=" + strSchType +
              "&schValue=" + Server.UrlEncode(strSchValue) + "&startDate=" + strStartDate + "&endDate=" + strEndDate + "&strSchRTtpe=" + strSchRType + "&strIs_Read=" + strIs_Read);

    }
    #endregion

    #region 메일 출력 갯수
    protected void ddlListCount_SelectedIndexChanged(object sender, System.EventArgs e)
    {
        MailBoxNameBind();
        GetMailList();
    }
    #endregion

    #region 메일 이동 함수
    /// <summary>
    /// 선택한 메일을 선택된 편지함으로 이동하는 함수
    /// </summary>
    /// <param name="mailbox"></param>
    /// <param name="mailid"></param>
    /// <returns></returns>
    private bool MoveMail(string mailbox, string mailid)
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception e)
        {
            JS.MessageBox(e.Message);
            return false;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prMoveMailbox";

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Cmd.Parameters.Add("@strUserId", OleDbType.VarChar).Value = strUserId;
            Cmd.Parameters.Add("@strDomain", OleDbType.VarChar).Value = strDomain;
            Cmd.Parameters.Add("@strMailIdx", OleDbType.VarChar).Value = mailid;
            Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt).Value = int.Parse(mailbox);

            Cmd.ExecuteNonQuery();

            int iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());

            if (iResult != 0)
            {
                if (iResult == -1)
                {
                    Trans.Rollback();
                    Con.Close();
                    JS.MessageBox("사용자 정보가 없습니다.");
                    return false;
                }
                else if (iResult == -2)
                {
                    Trans.Rollback();
                    Con.Close();
                    JS.MessageBox(strDomain + " 도메인에 대한 정보가 없습니다.");
                    return false;
                }
                else if (iResult == -3)
                {
                    Trans.Rollback();
                    Con.Close();
                    JS.MessageBox("해당 메일에 대한 정보가 없습니다.");
                    return false;
                }
            }

            Trans.Commit();
        }
        catch (Exception e)
        {
            Trans.Rollback();
            JS.MessageBox(e.Message);
            return false;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }

        return true;
    }
    #endregion

    protected void ibDetailSearch_Click(object sender, ImageClickEventArgs e)
    {
        string strSchValue = tbSearchValue.Text;
        string mailBox = ddlSearchMailbox.SelectedValue;
        string strSchType = ddlSearchType.SelectedValue;
        string strSearchPeriod = rblSearchPeriod.SelectedValue;
        strStartDate = tbStartPeriod.Text;
        strEndDate = tbEndPeriod.Text;
        DateTime date = DateTime.Now;

        if (strStartDate.Trim() == "" && strEndDate.Trim() == "")
        {
            strEndDate = date.ToString("yyyy-MM-dd");

            switch (strSearchPeriod)
            {
                case "0":
                    strStartDate = "";
                    strEndDate = "";
                    break;
                case "1":
                    strStartDate = date.AddDays(-7).ToString("yyyy-MM-dd");
                    break;
                case "2":
                    strStartDate = date.AddDays(-31).ToString("yyyy-MM-dd");
                    break;
                case "3":
                    strStartDate = date.AddDays(-91).ToString("yyyy-MM-dd");
                    break;
                case "4":
                    strStartDate = date.AddDays(-183).ToString("yyyy-MM-dd");
                    break;
                case "5":
                    strStartDate = date.AddDays(-365).ToString("yyyy-MM-dd");
                    break;
            }
        }

        //2010.01.28 뒤에 + "&strSchRTtpe=" + strSearchPeriod 추가했음
        JS.MovePage("ListMail.aspx?iPage=1&mailbox=" + mailBox + "&schType=" + strSchType + "&schValue=" + Server.UrlEncode(strSchValue) +
                "&startDate=" + strStartDate + "&endDate=" + strEndDate + "&strSchRTtpe=" + strSearchPeriod);
    }

    //10.02.01 읽은 메일로 변경하는 루틴 추가
    #region 읽은메일로 변경
    protected void ibMark_Read_Click(object sender, EventArgs e)
    {
        string strMailId = hidMailId.Value;

        //2011.04.04 카운트 부분 추가함
        iMailCount = int.Parse(this.hidicnt.Value);

        int iPage = 0;
        int iListCount = 0;

        if (strMailId == "")
        {
            JS.MessageBox("메일을 선택해 주세요.");
            JS.MovePage("ListMail.aspx?mailbox=" + strMailBox);
            return;
        }
        if (strMailId != "")
        {
            try
            {
                Con = new OleDbConnection(strCon);
                Con.Open();
                Trans = Con.BeginTransaction();
            }
            catch (Exception err)
            {
                JS.MessageBox(err.Message);
                return;
            }

            strMailId = strMailId.Replace("|", ",");

            if (strMailId.EndsWith(","))
                strMailId = strMailId.Substring(0, strMailId.Length - 1);

            try
            {
                Cmd.Connection = Con;
                Cmd.Transaction = Trans;
                Cmd.CommandType = CommandType.StoredProcedure;


                string[] mailId = strMailId.Split(',');

                Cmd.CommandText = "prUpdateMRead";

                Cmd.Parameters.Clear();

                Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strIdx", OleDbType.Integer);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strRead", OleDbType.Integer);
                Param.Direction = ParameterDirection.Input;

                Cmd.Parameters["@strUserId"].Value = strUserId;
                Cmd.Parameters["@strDomain"].Value = strDomain;
                Cmd.Parameters["@iMailboxIdx"].Value = strMailBox;
                Cmd.Parameters["@strRead"].Value = 1;


                for (int i = 0; i < mailId.Length; i++)
                {
                    Cmd.Parameters["@strIdx"].Value = int.Parse(mailId[i].Trim());
                    Cmd.ExecuteNonQuery();
                }

                Trans.Commit();


            }
            catch (Exception err)
            {
                Trans.Rollback();
                Con.Close();
                JS.MessageBox("읽은메일로 변경중 오류가 발생했습니다.\r\n" + err.Message);
                return;
            }
            finally
            {
                if (Con.State != ConnectionState.Closed)
                    Con.Close();
            }

            if (strPage == null)
                iPage = 1;
            else
            {
                if (strPage == "")
                    iPage = 1;
                else
                    iPage = int.Parse(strPage);
            }

            if (strListCount == null)
                iListCount = int.Parse(ddlListCount.SelectedValue);
            else
            {
                if (strListCount == "")
                    iListCount = int.Parse(ddlListCount.SelectedValue);
                else
                    iListCount = int.Parse(strListCount);
            }

            int iMod = iMailCount % iListCount;

            if (iMod == 0)
                iPage--;

            if (iPage <= 0)
                iPage = 1;

            strPage = iPage.ToString();

            JS.MovePage("ListMail.aspx?mailbox=" + Server.UrlEncode(strMailBox) + "&iPage=" + strPage + "&listCnt=" + strListCount + "&schType=" + strSchType +
               "&schValue=" + Server.UrlEncode(strSchValue) + "&startDate=" + strStartDate + "&endDate=" + strEndDate + "&strSchRTtpe=" + strSchRType + "&strIs_Read=" + strIs_Read);

            return;
        }


    }
    #endregion

    //10.02.01 읽은 메일로 변경하는 루틴 추가
    #region 읽지 않은 메일로 변경
    protected void ibMark_Unread_Click(object sender, EventArgs e)
    {
        string strMailId = hidMailId.Value;

        //2011.04.04 카운트 부분 추가함
        iMailCount = int.Parse(this.hidicnt.Value);

        int iPage = 0;
        int iListCount = 0;

        if (strMailId == "")
        {
            JS.MessageBox("메일을 선택해 주세요.");
            JS.MovePage("ListMail.aspx?mailbox=" + strMailBox);
            return;
        }
        if (strMailId != "")
        {
            try
            {
                Con = new OleDbConnection(strCon);
                Con.Open();
                Trans = Con.BeginTransaction();
            }
            catch (Exception err)
            {
                JS.MessageBox(err.Message);
                return;
            }

            strMailId = strMailId.Replace("|", ",");

            if (strMailId.EndsWith(","))
                strMailId = strMailId.Substring(0, strMailId.Length - 1);

            try
            {
                Cmd.Connection = Con;
                Cmd.Transaction = Trans;
                Cmd.CommandType = CommandType.StoredProcedure;


                string[] mailId = strMailId.Split(',');

                Cmd.CommandText = "prUpdateMRead";

                Cmd.Parameters.Clear();

                Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strIdx", OleDbType.Integer);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strRead", OleDbType.Integer);
                Param.Direction = ParameterDirection.Input;

                Cmd.Parameters["@strUserId"].Value = strUserId;
                Cmd.Parameters["@strDomain"].Value = strDomain;
                Cmd.Parameters["@iMailboxIdx"].Value = strMailBox;
                Cmd.Parameters["@strRead"].Value = 0;


                for (int i = 0; i < mailId.Length; i++)
                {
                    Cmd.Parameters["@strIdx"].Value = int.Parse(mailId[i].Trim());
                    Cmd.ExecuteNonQuery();
                }

                Trans.Commit();


            }
            catch (Exception err)
            {
                Trans.Rollback();
                Con.Close();
                JS.MessageBox("읽지 않은 메일로 변경중 오류가 발생했습니다.\r\n" + err.Message);
                return;
            }
            finally
            {
                if (Con.State != ConnectionState.Closed)
                    Con.Close();
            }

            if (strPage == null)
                iPage = 1;
            else
            {
                if (strPage == "")
                    iPage = 1;
                else
                    iPage = int.Parse(strPage);
            }

            if (strListCount == null)
                iListCount = int.Parse(ddlListCount.SelectedValue);
            else
            {
                if (strListCount == "")
                    iListCount = int.Parse(ddlListCount.SelectedValue);
                else
                    iListCount = int.Parse(strListCount);
            }

            int iMod = iMailCount % iListCount;

            if (iMod == 0)
                iPage--;

            if (iPage <= 0)
                iPage = 1;

            strPage = iPage.ToString();

            JS.MovePage("ListMail.aspx?mailbox=" + Server.UrlEncode(strMailBox) + "&iPage=" + strPage + "&listCnt=" + strListCount + "&schType=" + strSchType +
               "&schValue=" + Server.UrlEncode(strSchValue) + "&startDate=" + strStartDate + "&endDate=" + strEndDate + "&strSchRTtpe=" + strSchRType + "&strIs_Read=" + strIs_Read);

            return;
        }
    }
    #endregion
}
