﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Net;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.MailParse;
using Passkorea.MIME;


public partial class Mail_WriteMail : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter Param = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private MailParser mParser = null;
    private UserInfo UI;
    private WebFunction WF;
    private JavaScript JS;
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strMailId = "";
    private string strType = "";
    private string mTo = "";
    private string mCc = "";
    private string mSubject = "";
    private string mContent = "";
    protected string strUserId = "";
    protected string strDomain = "";
    protected string strEnc = "";
    protected string strMailBox = "";
    protected string strSign1 = "";
    protected string strSign2 = "";
    protected string strSign3 = "";
    protected string strHttpUrlRoot = "";
    protected long BigFileSize = 0; //대용량 파일에 남은 사이즈 
    protected string strFileUpload = ""; //모드에 따라서 태그변하는 변수 설정
    protected string strhidFileType = "";//모드 변경을 눌렀을때 변수 절정
    protected string strFileType = "";   //현재 업로드 모드
    protected string strSign = "";

    //2011.03.23 추가 서명 타입 선언
    protected string strSignType = "";
    protected string strSignTxt = "";

    private string tempmailtype = "";
    private string tempstrReceiveDate = "";
    
       
    protected void Page_Load(object sender, EventArgs e)
    {
    
        //2009년 5월 27일 추가 받는사람텍스트 박스에 onkeyup 이벤트를 먹이기 위해 선언
        this.txtSendTo.Attributes.Add("onkeyup", "return memaildir(this)");

        WF = new WebFunction();
        JS = new JavaScript(this.Page);
        JS.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        string strUserAgent = Request.ServerVariables["HTTP_USER_AGENT"].ToString();
        string strEmail = Request.Params["email"];
        
        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strMailId = Request.Params["mailId"];
        strMailBox = Request.Params["Mailbox"];
        strType = Request.Params["Type"];

        //10.01.19 추가
        strhidFileType = Request.Params["hidFileType"];

        if (strhidFileType != null)
        {//strhidFileType에 값이 있으면 모드변경을 클릭한것.

            //MAUL_USRE 테이블에서 FILE_UP_TYPE값 업데이트
            Update_Up_File_Type();
        }

        // 2014.02.25 - HTTPS 연결일 경우 그리고 HTTP 포트가 변경되어 있을 경우가 있어서 HTTPS와 포트 번호 붙이는 작업을 한다.
        string strPort = Request.Url.Port.ToString();
        string strIsHTTP = Request.ServerVariables["HTTPS"].ToString();
        string strUrl = Request.Url.LocalPath;

        strUrl = strUrl.Substring(0, strUrl.LastIndexOf("/"));

        if (strIsHTTP.ToLower() == "off")
            strHttpUrlRoot = "http://";
        else
            strHttpUrlRoot = "https://";

        strHttpUrlRoot += Request.ServerVariables["SERVER_NAME"];

        if (strPort != "80") strHttpUrlRoot += ":" + strPort;

        strHttpUrlRoot += strUrl;

        Response.ContentEncoding = Encoding.UTF8;
        Request.ContentEncoding = Encoding.UTF8;

        UI = new UserInfo(strUserId, strDomain, strCon);

        BigFileSize = UI.BigFileSize * 1048576 - UI.BigFileTotSize;

        //현재 유저 업로드 모드를 가져 오는 부분.
        //Setup_Type();
        strFileType = UI.File_Up_Type;

		//2013.03.29 IE가 아닐때는 무조건 T형식으로
        // [2013.11.14] - IE 11 지원되게 수정.
        if (strUserAgent.IndexOf("MSIE") == -1 &&
            (strUserAgent.ToUpper().IndexOf("TRIDENT") == -1 && strUserAgent.IndexOf("rv:11") == -1))
            strFileType = "T";

        this.hidMailConfirmOrg.Value = UI.Mail_Confirm_Allow;
        if (UI.Mail_Confirm_Allow == "Y")
            mailconfirm.Checked = true;
        else
            mailconfirm.Checked = false;

        //모드에 따라서 업로드 태그 변경.
        FileType();

        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        if (!IsPostBack)
        {
            AuthKey ak = new AuthKey();
            string strMsg = ak.CheckUserCount(UI.TotalUserCount(strDomain));

            if (strMsg != "")
                JS.MessageBox(strMsg);

            // 2014.04.04 임시 폴더를 삭제하고 새로 생성한다.
            // 원래 이 코드는 IsPostBack 코드 하단에 존재했지만 CID 이미지 임시 저장 문제로 먼저 삭제하고 생성하게 코드를 이전함.
            DirectoryInfo di = new DirectoryInfo(UI.UserPath + "\\temp");

            if (di.Exists)
            {
                di.Delete(true);
                di.Create();
            }
            else
                di.Create();

            // 2014.04.15 - 도메인 알리아스를 이용한 메일 발송자 주소 변경을 위해 초기화 사용.
            InitSenderEmailInfo();
            
            if (strMailId != null && strMailBox != null)
            {
                // 메일파일명과 메일박스명이 존재할때 해당 메일을 파싱해서
                // 쓰기폼으로 되돌려 준다.
                if (strMailId != "" && strMailBox != "")
                {
                    this.ThisMailParse();
                }
                hidMailId.Value = strMailId;
                hidMailBox.Value = strMailBox;
                hidType.Value = strType;
            }

            // 답장일 경우 보낸사람 주소를 넣는다.
            if (strType != null)
            {
                if (strType.ToLower() == "re" || strType.ToLower() == "ar")
                {
                    txtSendTo.Text = mTo;
                    txtSendCc.Text = mCc;
                }

                if (strType != "")
                    hidContent.Value = mContent;
            }
            else
            {
                if (strEmail != null)
                    mTo = strEmail;

                txtSendTo.Text = mTo;

                if (mCc != null)
                    txtSendCc.Text = mCc;

                hidContent.Value = mContent;
            }

            txtSendBcc.Text = "";
            txtMailSubject.Text = mSubject;

            //서명 바인드
            Signature();

            //2011.09.16 추가
            tempmailtype = Common.CheckIsNull(Request.Params["Savetype"], "0");
            this.hidSavetype.Value = tempmailtype;

            //2012.01.05
            //임시저장일때 서명이 안붙도록 수정함
            if (tempmailtype == "1")
            {
                this.mf_body_html.Value = mContent;
            }
            else
            {
                //2010.03.23일 서명부분 추가함.
                if (strSignType == "0")
                {
                    //본문내용을 넣는부분
                    this.mf_body_html.Value = mContent;
                }
                else if (strSignType == "1")
                {
                    this.mf_body_html.Value = "<p></p><p></p><p>" + strSignTxt + mContent;
                }
            }
           
            Page.DataBind();

            //2011.09.16 추가
            if (tempmailtype == "1")
            {
                if (tempstrReceiveDate == "")
                    this.latempdata.Text = "임시저장 : " + DateTime.Now.ToString();
                else
                    this.latempdata.Text = "임시저장 : " + tempstrReceiveDate;

                this.hidTempMailType.Value = "1";
            }
        }
    }

    #region 회신, 전체회신, 전달시 또는 임시 저장메일 파싱
    /// <summary>
    /// 회신, 전체회신, 전달시 또는 임시 저장메일 파싱한다.
    /// </summary>
    private void ThisMailParse()
    {
        string strContent = null;
        string msgHeader = "";
        string strMailboxNo = "";
        string strSubject = "";
        string strFrom = "";
        string strTo = "";
        string strCc = "";
        string strContentHtml = "";
        string strContentText = "";
        string strReceiveDate = "";
        string strMailFile = "";
        int iAttachCount = 0;
        OleDbDataReader reader;
        WebFunction WF = new WebFunction();

        // 2014.04.04 cid_temp 삭제 생성하던 코드 삭제.
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception e)
        {
            JS.MessageBox(e.Message);
            JS.HistoryBack();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prViewMailContent";

            Cmd.Parameters.Clear();

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Cmd.Parameters.Add("@strUserId", OleDbType.VarChar).Value = strUserId;
            Cmd.Parameters.Add("@strDomain", OleDbType.VarChar).Value = strDomain;
            Cmd.Parameters.Add("@iMcIdx", OleDbType.Integer).Value = int.Parse(strMailId);
            Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt).Value = int.Parse(strMailBox);

            reader = Cmd.ExecuteReader();

            if (Cmd.Parameters["@iResult"].Value != null)
            {
                int iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());

                // 에러처리
            }
            else
            {
                if (reader.HasRows)
                {
                    reader.Read();
                    
                    strMailboxNo = reader["Mc_Mailbox_No"].ToString();
                    strSubject = reader["Mc_Subject"].ToString();
                    strFrom = reader["Mc_From"].ToString();
                    strTo = reader["Mc_To"].ToString();
                    strCc = reader["Mc_Cc"].ToString();
                    strContentHtml = reader["Mc_Body_Html"].ToString();
                    strContentText = reader["Mc_Body_Text"].ToString();
                    iAttachCount = int.Parse(reader["Mc_Attach_Count"].ToString());
                    strReceiveDate = reader["Mc_Receive_Date"].ToString();
                    strMailFile = reader["Mc_Filename"].ToString();

                    hidMailBoxNo.Value = strMailboxNo;
                    hidMailFile.Value = strMailFile;

                    //2011.09.19 추가
                    tempstrReceiveDate = reader["Mc_Receive_Date"].ToString();
                }
            }

            reader.Close();
        }catch (Exception e)
        {
            JS.MessageBox(e.Message);
            JS.HistoryBack();
            return;
        }
        
        try
        {
            if (iAttachCount > 0)
            {
                Cmd.Parameters.Clear();
                Cmd.CommandText = "prListAttachFiles";

                Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
                Param.Direction = ParameterDirection.ReturnValue;

                Cmd.Parameters.Add("@strUserId", OleDbType.VarWChar).Value = strUserId;
                Cmd.Parameters.Add("@strDomain", OleDbType.VarWChar).Value = strDomain;
                Cmd.Parameters.Add("@strMailFile", OleDbType.VarWChar).Value = strMailFile;

                reader = Cmd.ExecuteReader();

                if (reader.HasRows)
                {
                    while (reader.Read())
                    {
                        string sFileName = reader["Ma_Attach_File"].ToString();
                        string strAttachFile = sFileName;

                        if (strAttachFile.Trim() != "")
                        {
                            if (strAttachFile.StartsWith(" "))
                                strAttachFile = strAttachFile.Substring(1);

                            strAttachFile = strAttachFile.Replace("'", "\\'");

                            if (sFileName.StartsWith(" "))
                                sFileName = sFileName.Substring(1);

                            // 첨부파일 임시 저장 폴더에 저장
                            if (!Directory.Exists(UI.UserPath + "\\attach_temp"))
                                Directory.CreateDirectory(UI.UserPath + "\\attach_temp");
                            
                            /* 2014.02.28 - CID 이미지가 첨부파일로 저장되어 있지 않아도 사용할 수 있게 Passkorea.dll 컴포넌트 내에서 수정해 놓아서 아래 구문을 사용할 필요가 없습니다.
                             * 대신 아랫쪽 본문 내용 처리 부분에 CID 이미지 링크를 변경하는 코드를 추가해서 사용해야 합니다.
                            MailParser mParser = new MailParser(UI.UserPath, strMailboxNo, strMailFile);

                            string CidNameTemp = "";

                            CidNameTemp = mParser.CidFileSave(UI.UserPath + "\\attach_temp\\", UI.UserPath + "\\" + strMailboxNo + "\\" + strMailFile, sFileName, UI.UserPath + "\\cid_temp\\");

                            //2010.03.08 Cid 이미지가 있으면 Cid 이미지이름을 가져 오기
                            if (CidNameTemp != "")
                            {
                                this.hidCid.Value += CidNameTemp + "|";
                            }
                            */
                        }
                    }
                }
                reader.Close();
            }

            // 전달 또는 답장이 아닐때 파싱한 주소를 쓰기폼으로 돌려준다.
            if (strType == null)
            {
                mSubject = strSubject;
                mTo = strTo.Replace("|", " ").Replace("<", "").Replace(">", "");
                mTo = mTo.Replace(";", ",");
                
                if (mTo.EndsWith(","))
                    mTo = mTo.Substring(0, mTo.Length - 1);

                if (strCc != null)
                    mCc = strCc.Replace("|", " ").Replace("<", "").Replace(">", "");
            }
            else
            {
                // 2008년 11월 26일
                // 회신 또는 전달일 때 제목 입력하는 부분에 제목이 빠지는 문제때문에 수정.
                mSubject = strSubject;

                // 쓰기 또는 전달일때
                if (strType.ToLower() == "re")
                {
                    mSubject = "Re: " + mSubject;
                    mTo = strFrom.Replace("|", " ");
                }
                else if (strType.ToLower() == "ar")
                {
                    mSubject = "Re: " + mSubject;
                    // Sender Email Address (Mail From)

                    //2010.02.01 from 값을 집어 넣을때 본인 아이디가 있으면 제외 시킨다.
                    //mTo = strFrom.Replace("|", " ");
                    if (strFrom.Replace("|", " ").IndexOf(strUserId + "@" + strDomain) < 0)
                        mTo = strFrom.Replace("|", " ");

                    //2010.02.01 받는사람.
                    // Received Email Address (Mail To)
                    if (strTo != null && strTo != "")
                    {
                        string strValue = "";
                        //2010.02.01 DB에 들어 가 있는구분자는 ; 이다.
                        //string[] strTmp = strTo.Split(',');
                        string[] strTmp = strTo.Split(';');

                        //JS.MessageBox(strTmp.Length.ToString());

                        // 받는사람 메일 주소에 사용자 메일주소가 존재하는지 체크
                        // 존재하면 사용자 메일주소는 제외한다.
                        for (int iCnt = 0; iCnt < strTmp.Length; iCnt++)
                        {
                            if (strTmp[iCnt].IndexOf(strUserId + "@" + strDomain) < 0)
                                strValue += strTmp[iCnt] + ",";
                        }

                        //2010.02.01 indexOf는 처음 시작값이다. 마지막값을 알려면 LastIndexOf 이다.
                        // 문자열 마지막에 콤마(,)가 존재하면 제거한다.
                        //if (strValue.Length == strValue.IndexOf(","))
                        if (strValue != "")
                        {
                            if (strValue.Length == strValue.LastIndexOf(",") + 1)
                                strValue = strValue.Substring(0, strValue.Length - 1);
                        }
                        //2010.02.01 합혀지는 값을 strValue와 mTo 값이다.
                        //mTo += "," + strTo.Replace("|", " ");

                        if (mTo == "")
                        {
                            if (strValue != "")
                                mTo += strValue;
                            else
                                mTo = mTo;
                        }
                        else
                        {
                            if (strValue != "")
                                mTo += "," + strValue;
                            else
                                mTo = mTo;
                        }

                    }
                    //2010.02.01 참조.
                    // 기존에는 받는사람으로 들어 갔는데 참조는 참조로 들어 가며 참조일때도 사용자 메일주소가 존재하면 제외 시키는 루틴 추가함.
                    // Received Email Address (Mail Cc)
                    //if (strCc != null && strCc != "")
                    //    mTo += "," + strCc.Replace("|", " ");
                    if (strCc != null && strCc != "")
                    {
                        string strValue2 = "";
                        //2010.02.01 DB에 들어 가 있는구분자는 ; 이다.
                        //string[] strTmp = strTo.Split(',');
                        string[] strTmp2 = strCc.Split(';');

                        //JS.MessageBox(strTmp.Length.ToString());

                        // 받는사람 메일 주소에 사용자 메일주소가 존재하는지 체크
                        // 존재하면 사용자 메일주소는 제외한다.
                        for (int iCnt = 0; iCnt < strTmp2.Length; iCnt++)
                        {
                            if (strTmp2[iCnt].IndexOf(strUserId + "@" + strDomain) < 0)
                                strValue2 += strTmp2[iCnt] + ",";
                        }

                        //2010.02.01 indexOf는 처음 시작값이다. 마지막값을 알려면 LastIndexOf 이다.
                        // 문자열 마지막에 콤마(,)가 존재하면 제거한다.
                        //if (strValue.Length == strValue.IndexOf(","))
                        if (strValue2 != "")
                        {
                            if (strValue2.Length == strValue2.LastIndexOf(",") + 1)
                                strValue2 = strValue2.Substring(0, strValue2.Length - 1);
                        }

                        if (strValue2 != "")
                            mCc = strValue2;
                    }
                }
                else if (strType.ToLower() == "fw")
                {
                    mSubject = "Fw: " + mSubject;

                    if (iAttachCount > 0)
                    {

                        Cmd.Parameters.Clear();
                        Cmd.CommandText = "prListAttachFiles";

                        Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
                        Param.Direction = ParameterDirection.ReturnValue;

                        Cmd.Parameters.Add("@strUserId", OleDbType.VarWChar).Value = strUserId;
                        Cmd.Parameters.Add("@strDomain", OleDbType.VarWChar).Value = strDomain;
                        Cmd.Parameters.Add("@strMailFile", OleDbType.VarWChar).Value = strMailFile;

                        reader = Cmd.ExecuteReader();
                        
                        if (reader.HasRows)
                        {
                            bool bEnd = false;

                            HtmlTableRow row = new HtmlTableRow();
                            HtmlTableCell cell = new HtmlTableCell();

                            cell.ColSpan = 2;
                            cell.InnerHtml = "<font color=\"blue\" style=\"fone-size:9pt;\">※ <b>첨부되는 파일이 있습니다.</b></font>";

                            row.Cells.Add(cell);
                            tblAttachFiles.Rows.Add(row);

                            while (reader.Read())
                            {
                                string sFileName = reader["Ma_Attach_File"].ToString();
                                string strAttachFile = sFileName;
                                
                                if (strAttachFile.Trim() != "")
                                {
                                    if (strAttachFile.StartsWith(" "))
                                        strAttachFile = strAttachFile.Substring(1);
                                    
                                    strAttachFile = strAttachFile.Replace("'", "\\'");
                                    
                                    if (sFileName.StartsWith(" "))
                                        sFileName = sFileName.Substring(1);

                                    if (!bEnd)
                                    {
                                        row = new HtmlTableRow();
                                        bEnd = true;
                                    }
                                    else
                                    {
                                        tblAttachFiles.Rows.Add(row);
                                        bEnd = false;
                                    }

                                    cell = new HtmlTableCell();
                                    cell.Width = "50%";
                                    cell.InnerHtml = "<input type=\"checkbox\" checked id=\"cbFwFile\" name=\"cbFwFile\" onclick=\"javascript: obj_Checked(this.checked, this.value, 'hidFwFile', ':');\" value=\"" + sFileName + "\">" + sFileName;
                                    row.Cells.Add(cell);

                                    this.hidFwFile.Value += sFileName + ":";
                                }
                            }

                            if (bEnd)
                            {
                                cell = new HtmlTableCell();
                                cell.Width = "50%";
                                cell.InnerHtml = "&nbsp;";
                                row.Cells.Add(cell);

                                tblAttachFiles.Rows.Add(row);
                            }
                        }

                        reader.Close();
                    }
                    else
                        tblAttachFiles.Visible = false;
                }
                else
                    mSubject = strSubject;
            }

            //2010.12.20 임시 저장함일때도 파일이 오도록 추가함.
            if (strMailBox == "301")
            {
                if (iAttachCount > 0)
                {

                    Cmd.Parameters.Clear();
                    Cmd.CommandText = "prListAttachFiles";

                    Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
                    Param.Direction = ParameterDirection.ReturnValue;

                    Cmd.Parameters.Add("@strUserId", OleDbType.VarWChar).Value = strUserId;
                    Cmd.Parameters.Add("@strDomain", OleDbType.VarWChar).Value = strDomain;
                    Cmd.Parameters.Add("@strMailFile", OleDbType.VarWChar).Value = strMailFile;

                    reader = Cmd.ExecuteReader();

                    if (reader.HasRows)
                    {
                        bool bEnd = false;

                        HtmlTableRow row = new HtmlTableRow();
                        HtmlTableCell cell = new HtmlTableCell();

                        cell.ColSpan = 2;
                        cell.InnerHtml = "<font color=\"blue\" style=\"fone-size:9pt;\">※ <b>첨부되는 파일이 있습니다.</b></font>";

                        row.Cells.Add(cell);
                        tblAttachFiles.Rows.Add(row);

                        while (reader.Read())
                        {
                            string sFileName = reader["Ma_Attach_File"].ToString();
                            string strAttachFile = sFileName;

                            if (strAttachFile.Trim() != "")
                            {
                                if (strAttachFile.StartsWith(" "))
                                    strAttachFile = strAttachFile.Substring(1);

                                strAttachFile = strAttachFile.Replace("'", "\\'");

                                if (sFileName.StartsWith(" "))
                                    sFileName = sFileName.Substring(1);

                                if (!bEnd)
                                {
                                    row = new HtmlTableRow();
                                    bEnd = true;
                                }
                                else
                                {
                                    tblAttachFiles.Rows.Add(row);
                                    bEnd = false;
                                }

                                cell = new HtmlTableCell();
                                cell.Width = "50%";
                                cell.InnerHtml = "<input type=\"checkbox\" checked id=\"cbFwFile\" name=\"cbFwFile\" onclick=\"javascript: obj_Checked(this.checked, this.value, 'hidFwFile', ':');\" value=\"" + sFileName + "\">" + sFileName;
                                row.Cells.Add(cell);
                                this.hidFwFile.Value += sFileName + ":";
                            }
                        }

                        if (bEnd)
                        {
                            cell = new HtmlTableCell();
                            cell.Width = "50%";
                            cell.InnerHtml = "&nbsp;";
                            row.Cells.Add(cell);

                            tblAttachFiles.Rows.Add(row);
                        }
                    }

                    reader.Close();
                }
                else
                    tblAttachFiles.Visible = false;
            }

            if (strContentHtml != "")
            {
                if (strType != null)
                {
                    if (strType.ToLower() == "fw")
                        msgHeader = "<p><br>\r\n<br>\r\n---------- Original Message ----------</p>";
                    else
                        msgHeader = "<br>\r\n<br>\r\n<hr><br>\r\n";

                    msgHeader += "<p>From: " + WF.linkMailAddress(strFrom) + "</p>" +
                        "<p>To: " + WF.linkMailAddress(strTo.Replace(";", ",")) + "</p>" +
                        "<p>Sent: " + strReceiveDate + "</p>" +
                        "<p>Subject: " + strSubject + "<br><br><br></p>";
                }

                // 2014.02.25 - Cid 이미지 링크 때문에 아래 구문 사용
                strContentHtml = WF.ChkContentCid(strContentHtml, strHttpUrlRoot + "/ViewCidImage.aspx", strMailboxNo, strMailFile);
                strContent = strContentHtml;
            }
            else
            {
                if (strType != null)
                {
                    if (strType.ToLower() == "fw")
                        msgHeader = "<br>---------- Original Message ----------<br>\r\n";
                    else
                        msgHeader = "<br><hr>\r\n";

                    msgHeader += "From: " + strFrom.Replace("<", "&lt") + "<br>\r\n" +
                        "To: " + strTo.Replace(";", ",").Replace("<", "&lt") + "<br>\r\n" +
                        "Sent: " + strReceiveDate + "<br>\r\n" +
                        "Subject: " + strSubject + "<br><br>\r\n\r\n";
                }

                strContent = strContentText;
                strContent = strContent.Replace("<", "&lt");
                strContent = strContent.Replace("\r\n", "<br>\r\n");
            }
        }
        catch (Exception err)
        {
            // 오류 처리
            string strMsg = "";

            if (strType == null)
                strMsg = "임시 저장 편지 ";
            else if (strType.ToLower() == "re")
                strMsg = "회신";
            else if (strType.ToLower() == "ar")
                strMsg = "전체회신";
            else if (strType.ToLower() == "fw")
                strMsg = "전달";

            JS.MessageBox(strMsg + " 중인 메일을 파싱하는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            JS.HistoryBack();
            return;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }

        mContent = msgHeader + strContent;
    }
    #endregion

    #region 본문 내용을 hidContent에 넣는다.
    /// <summary>
    /// 본문 내용을 hidContent에 넣는다.
    /// </summary>
    private string ContentValue()
    {
        StringBuilder sb = new StringBuilder();
        sb.Append("	var getDocument = document.getElementById(\"wysiwygtxtEditor\").contentWindow.document;");
        sb.Append("");
        sb.Append("	if (document.frmWriteMail.chkWriteType[0].checked)");
        sb.Append("	{");
        sb.Append("		document.frmWriteMail.hidWriteType.value = 'Text';");
        sb.Append("		document.frmWriteMail.hidContent.value = document.frmWriteMail.txtTextContent.value;");
        sb.Append("	}");
        sb.Append("	else if (document.frmWriteMail.chkWriteType[1].checked)");
        sb.Append("	{");
        sb.Append("		document.frmWriteMail.hidWriteType.value = 'Html';");
        sb.Append("		document.frmWriteMail.hidContent.value = getDocument.body.innerHTML;");
        sb.Append("	}");

        return sb.ToString();
    }
    #endregion

    #region 그룹 확인
    private string CheckGroup(string strMailAddr)
    {
        string[] arrValue = null;
        string strValue = "";
        int iCnt = 0;

        if (strMailAddr == "") return "";

        arrValue = strMailAddr.Split(';');
        iCnt = arrValue.Length;

        if (iCnt > -1)
        {
            for (int iLoop = 0; iLoop < iCnt; iLoop++)
            {
                // 2006년 12월 22일 수정
                // 메일주소값이 빈문자열 일때 해당 루틴을 건너뛰도록 함.
                if (arrValue[iLoop].Trim() != "")
                {
                    if (arrValue[iLoop].Substring(0, 1) == "⊙")
                        strValue += this.GetGroupAddr(arrValue[iLoop].Substring(1));
                    else
                        strValue += arrValue[iLoop] + ";";
                }
            }

            if (strValue.Trim() != "")
                strValue = strValue.Substring(0, strValue.LastIndexOf(";"));
        }

        return strValue;
    }
    #endregion

    #region 그룹에 등록된 주소를 가져온다.
    /// <summary>
    /// 그룹에 등록된 메일 주소를 가져온다.
    /// </summary>
    /// <param name="strGroup"></param>
    /// <returns></returns>
    private string GetGroupAddr(string strGroup)
    {
        string strAddr = "";
        string strCommon = "";

        // 2006년 11월 22일 수정
        // 그룹 메일 발송시 공유 그룹으로 발송 못하던 문제 수정
        // 그룹명에 구분자를 넣어서 공유 그룹인지 개인 그룹인지 확인
        if (strGroup.IndexOf("‡") > 0)
        {
            strCommon = strGroup.Substring(strGroup.IndexOf("‡") + 1, 1);
            strGroup = strGroup.Substring(0, strGroup.IndexOf("‡"));
        }
        else
            strCommon = "N";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            return "";
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListGroupEmail";

            Cmd.Parameters.Clear();

            Cmd.Parameters.Add("@varUserId", OleDbType.VarChar).Value = strUserId;
            Cmd.Parameters.Add("@varDomain", OleDbType.VarChar).Value = strDomain;
            Cmd.Parameters.Add("@varGroup", OleDbType.VarWChar).Value = strGroup;
            Cmd.Parameters.Add("@chrCommon", OleDbType.Char).Value = strCommon;


            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_ADDRESS");
            dt = ds.Tables["MAIL_ADDRESS"];

            foreach (DataRow dr in dt.Rows)
                strAddr += dr["EMAIL_ADDR"].ToString() + ";";
        }
        catch (Exception err)
        {
            JS.MessageBox(strGroup + " 그룹에서 주소를 가져오는 도중 오류가 발생했습니다.\r\n" +
                "오류 내용: " + err.Message);
        }
        finally
        {
            Con.Close();
            ds.Clear();
        }

        return strAddr;
    }
    #endregion

    #region Temp 폴더 삭제
    private void DeleteTempDirectory(bool bFiles)
    {
        DirectoryInfo di = new DirectoryInfo(UI.UserPath + "\\temp");
        
        if (di.Exists)
        {
            di.Delete(true);
            di.Create();
        }
        else
            di.Create();
    }
    #endregion

    #region 서명정보 바인드
    /// <summary>
    /// 서명정보를 가져온다.
    /// </summary>
    private void Signature()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            JS.HistoryBack();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prSelectSign";

            Cmd.Parameters.Clear();

            Cmd.Parameters.Add("@varUserId", OleDbType.VarChar).Value = strUserId;
            Cmd.Parameters.Add("@varDomain", OleDbType.VarChar).Value = strDomain;
            
            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "SIGN_INFO");
            dt = ds.Tables["SIGN_INFO"];
            int iRowCount = dt.Rows.Count;

            if (iRowCount > 0)
            {
                //2010.03.23일 서명부분 추가함.
                strSignType = dt.Rows[0]["S_SIGN_TYPE"].ToString();

                if (strSignType == "0" || strSignType == " ")
                {
                    this.trSign.Visible = true;

                    if (strSignType == " ")
                    {
                        strSignType = "0";
                        strSign = "0";
                    }
                    else
                    {
                        strSign = dt.Rows[0]["S_SIGN"].ToString();
                    }

                    if (strSign == rdoSign0.Value)
                    {
                        rdoSign0.Checked = true;
                    }
                    else if (strSign == rdoSign1.Value)
                    {
                        rdoSign1.Checked = true;
                    }
                    else if (strSign == rdoSign2.Value)
                    {
                        rdoSign2.Checked = true;
                    }
                    else if (strSign == rdoSign3.Value)
                    {
                        rdoSign3.Checked = true;
                    }

                    this.tbSignature.Value = strSign;
                }
                else if (strSignType == "1")
                {
                    this.trSign.Visible = false;

                    strSign = dt.Rows[0]["S_SIGN"].ToString();

                    if (strSign == "1")
                    {
                        if (dt.Rows[0]["S_SIGN1_USE"].ToString() == "1")
                            strSignTxt = dt.Rows[0]["S_SIGN1"].ToString();
                        else
                            strSignTxt = dt.Rows[0]["S_SIGN1"].ToString().Replace("\r\n", "<br>\r\n");
                    }
                    else if (strSign == "2")
                    {
                        if (dt.Rows[0]["S_SIGN2_USE"].ToString() == "1")
                            strSignTxt = dt.Rows[0]["S_SIGN2"].ToString();
                        else
                            strSignTxt = dt.Rows[0]["S_SIGN2"].ToString().Replace("\r\n", "<br>\r\n");
                    }
                    else if (strSign == "3")
                    {
                        if (dt.Rows[0]["S_SIGN3_USE"].ToString() == "1")
                            strSignTxt = dt.Rows[0]["S_SIGN3"].ToString();
                        else
                            strSignTxt = dt.Rows[0]["S_SIGN3"].ToString().Replace("\r\n", "<br>\r\n");
                    }

                    this.tbSignature.Value = strSign;

                }
            }
        }
        catch (Exception err)
        {
            JS.MessageBox("서명 정보를 가져오는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            JS.MovePage("WriteMail.aspx");
            return;
        }
    }
    #endregion
    
    #region 업로드타입에 따라서 태그 수정
    /// <summary>
    /// 업로드타입에 따라서 태그 수정. 10.01.21추가
    /// </summary>
    public void FileType()
    {
        if (strFileType == "A")
        {   //10.01.28 폴더 업로드 추가함 AddFolder
            strFileUpload = "[<a href=\"JavaScript:fileuptype('T')\"><b>Text 모드로 전환</b></a>]" +
                            "<table cellSpacing=\"0\" cellPadding=\"0\" width=\"100%\" border=\"0\">\r\n " +
                                "<tr height=\"30\">\r\n " +
                                    "<td align=\"left\" style=\"padding-left:5px;\" nowrap=\"nowrap\">\r\n " +
                                        "<a href=\"javascript: AttachFile();\"><img src=\"../images/btn_09.gif\" alt=\"\" valign=\"absmiddle\" style=\"border:0;\" width=\"45\" height=\"22\" /></a>\r\n " +
                                        "<a href=\"javascript: AddFolder();\"><img src=\"../images/btn_119.gif\" alt=\"\" valign=\"absmiddle\" style=\"border:0;\" width=\"59\" height=\"22\" /></a>\r\n " +
                                        "<a href=\"javascript: DeleteFile();\"><img src=\"../images/btn_04.gif\" alt=\"\" valign=\"absmiddle\" style=\"border:0;\" width=\"45\" height=\"22\" /></a>\r\n " +
                                    "</td>\r\n " +
                                    "<td nowrap=\"nowrap\"></td>\r\n " +
                                    "<td align=\"right\" style=\"padding-right:5px;\" nowrap=\"nowrap\">\r\n " +
                                            "일반첨부 : <b><span id=\"sUploadSize\">0.00K</span></b> / <b><span id=\"sUploadTotSize\"></span></b><span style=\"color: #999999;\">|</span>\r\n " +
                                            "대용량첨부 : <b><span id=\"sUploadNewBigSize\">0.00K</span></b> / <b><span id=\"sUploadBigSize\"></span></b>\r\n " +
                                    "</td>\r\n " +
                                "</tr>\r\n " +
                                "<tr height=\"80\">\r\n " +
                                    "<td align=\"left\"  style=\"padding-left:5px;\" colspan=\"3\">\r\n " +
                                   "<script language=\"javascript\" type=\"text/javascript\" src=\"../Common/JsObjUploader.js?d=20100230\"></script>\r\n " +
                                    "</td>\r\n " +
                                "</tr>\r\n " +
                            "</table>\r\n ";
        }
        else
        {
            strFileUpload = "[<a href=\"JavaScript:fileuptype('A')\"><b>ActiveX 모드로 전환</b></a>]<br>" +
                            "<iframe name=\"file_up\" id=\"file_up\" src=\"File_Upload.aspx\" width=\"755\" height=\"135\" frameborder=\"0\"  style=\"text-align:right\"></iframe>";
        }
    }
    #endregion

    #region 업로드 타입을 수정
    /// <summary>
    /// 업로드 타입을 수정 10.01.21추가
    /// </summary>
    public void Update_Up_File_Type()
    {
        string strSql = "";

        strSql = "UPDATE MAIL_USER SET FILE_UP_TYPE = '" + strhidFileType + "' WHERE USER_ID = '" + strUserId + "' AND USER_DOMAIN = '" + strDomain + "'";

        string strValue= SetupModify.Modify(strSql);

        if (strValue.IndexOf("오류가") == 0)
            JS.MessageBox("오류가 발생했습니다." + strValue);
    }
    #endregion

    #region 알리아스 도메인으로 된 메일주소를 생성한다.
    // 2014.04.15 - 발신자 메일주소 변경 때문에 추가.
    /// <summary>
    /// 
    /// </summary>
    private void InitSenderEmailInfo()
    {
        string strEmail = strUserId + "@" + strDomain;
        string[] aliasDomain = Domain.GetAliasDomain(strDomain, strCon);

        ddlSenderEmail.Items.Add(new ListItem(UI.UserName + " <" + strEmail + ">", strEmail));

        if (aliasDomain != null)
        {
            for (int i = 0; i < aliasDomain.Length; i++)
            {
                strEmail = strUserId + "@" + aliasDomain[i];

                ddlSenderEmail.Items.Add(new ListItem(UI.UserName + " <" + strEmail + ">", strEmail));

                if (UI.SenderEmailAddr == strEmail) ddlSenderEmail.SelectedIndex = i + 1;
            }
        }

        ddlSenderEmail.DataBind();

        if (UI.UseSenderEmail)
        {
            chkUseSenderEmail.Checked = true;
            ddlSenderEmail.Enabled = true;
            hidUseSenderEmail.Value = "Y";
        }
        else
        {
            ddlSenderEmail.SelectedIndex = 0;
            ddlSenderEmail.Enabled = false;
            hidUseSenderEmail.Value = "N";
        }
    }
    #endregion       
}
